{
  Dieses Programm sollte ein Thumbnail-Viewer fr Grafikdateien werden. Es
  wurde nie fertiggestellt. Es enthlt aber einige interessante Routinen zur
  Ansprechung des VESA-Bios auf Grafikkarten, und zum Zeichnen von Fenstern
  etc..
}

uses crt,dos;

const rev : string = '13/12/1996';
      mbitmap : array [0..7] of byte = (128,64,32,16,8,4,2,1);

type picArray = array [0..(64*64-1)] of byte;
     colArray = array [0..15,0..2] of byte;

var pic        : array [0..13] of picArray;
    mscreen    : array [0..7,0..7] of byte;
    moldPos    : word;
    windowStart2 : word;
    col        : array [0..13] of colArray;
    vesa105  : boolean;
    windowStart : word;
    biosFont : pointer;
    vesaInfo : record
		 sig     : array [0..3] of byte;
		 lowVer  : byte;
		 highVer : byte;
		 prod	 : pointer;
		 nop     : longint;
		 modes   : pointer;
		 nops    : array [0..256-18] of byte;
               end;
    modeInfo : record
    		 modeFlag : word;
                 winFlag1 : byte;
                 winFlag2 : byte;
                 winGran  : word;
                 winSize  : word;
                 winSeg1  : word;
                 winSeg2  : word;
                 fp	  : pointer;
                 nbytes   : word;
                 xRes	  : word;
                 yRes	  : word;
                 length   : byte;
		 height   : byte;
		 bitPlanes: byte;
		 bitspixel: byte;
		 memblocks: byte;
		 memMode  : byte;
		 blockSize: byte;
		 nops : array [0..256] of byte;
	       end;

procedure move; assembler;
asm
    pusha
    push es
    inc windowStart
    mov dx, windowStart
    mov ax, 4f05h
    xor bx, bx
    int 10h
    pop es
    popa
end;


{ Zeichnet eine ausgefllte Box mit Rand und Schatten }
procedure box( x1 , y1 , x2 , y2 : word ; lineCol1 , lineCol2 , fillCol : byte ); assembler;
  asm
    { Variablen auf ungltige Werte checken... }
    mov ax, y2
    cmp ax, 768
    jb @ok_1
    jmp @error
   @ok_1:
    cmp y1, ax
    jb @ok_2
    jmp @error
   @ok_2:
    mov ax, x2
    cmp ax, 1024
    jb @ok_3
    jmp @error
   @ok_3:
    cmp x1, ax
    jb @ok_4
    jmp @error
   @ok_4:

    { Absoluten Offset im Video-Ram berechnen...
      Wird in EDI abgelegt...
    }
    db 66h ; xor di, di			{ xor edi, edi }
    mov di, x1				{ mov di, x1 }
    db 66h ; xor ax, ax			{ xor eax, eax }
    mov ax, y1				{ mov ax, y1 }
    db 66h ; shl ax, 10d		{ shl eax, 10d }
    db 66h ; add di, ax			{ add edi, eax }

    { Zugriffsfenster auf das nchst kleinere 64k-Vielfache setzen...
      Wird in "windowStart" abgelegt ...
    }
    db 66h ; mov dx, di			{ mov edx, edi }
    db 66h ; shr dx, 16			{ shr edx, 16 }
    mov windowStart, dx
    mov ax, 4f05h
    xor bx, bx
    int 10h

    { ES auf das Fenster-Segment $a000 setzen... }
    mov ax, 0a000h
    mov es, ax

    { Anzahl Pixel pro Zeile vorberechnen und im Code patchen...
      wegen Rahmen und Schatten 5 subtrahieren...
    }
    mov dx, x2
    sub dx, x1
    sub dx, 4
    mov bx, dx
    mov ax, dx
    shr bx, 2
    mov cs:word ptr @patch03+1, bx
    and ax, 3
    mov cs:word ptr @patch04+1, ax

    { Zeilensprung-Konstante berechnen...
      Wird direkt im Code gepatcht...
    }
    mov ax, 1024
    sub ax, dx
    sub ax, 5
    mov cs:word ptr @patch01+2, ax
    mov cs:word ptr @patch05+2, ax
    mov cs:word ptr @patch06+2, ax
    mov cs:word ptr @patch07+2, ax

    { Anzahl Y-Zeilen berechnen, 3 subtrahieren (wegen Rahmen ) }
    mov bx, y2
    sub bx, y1
    sub bx, 2

    { Oberste Zeile ( Rahmen ) zeichnen }
    add dx, 2
    mov al, lineCol1
    mov cx, dx
    rep stosb
    add di, 2

    mov al, fillCol
    mov ah, fillCol
    db 66h ; shl ax, 16d
    mov al, fillCol
    mov ah, fillCol

    jmp @patch01

   @lineLoop:
    mov al, lineCol1
    stosb
    mov al, fillCol
   @patch03:
    db 0b9h, 0 , 0			{ mov cx, ... }
    db 66h ; rep stosw
   @patch04:
    db 0b9h, 0, 0			{ mov cx, ... }
    rep stosb
    mov al, lineCol2
    stosb
    xor al, al
    stosb
    stosb
    stosb
    { checken, ob Ende des Zugriffsfensters... }
    or di, di
    jnz @patch01
    call move

   @patch01:
    db 81h, 0c7h , 0 , 0		{ add di, .... }
    { checken, ob Fenster-berlauf... }
    jc @goMove
   @lb1:
    dec bx
    jz @doneAll
    jmp @lineLoop
   @goMove:
    call move
    jmp @lb1

   @doneAll:

    { Rahmen-Zeile zeichnen }
    mov al, lineCol2
    mov cx, dx
    rep stosb
    { noch 'n Stck Schatten }
    xor al, al
    stosb
    stosb
    stosb
    { checken, ob Ende des Zugriffsfensters... }
    or di, di
    jnz @ok_a
    call move
   @ok_a:

    add dx, 3
    { erste Schatten-Zeile zeichnen }
   @patch05:
    db 81h, 0c7h , 0 , 0		{ add di, .... }
    jnc @ok
    call move
   @ok:
    xor al, al
    mov cx, dx
    rep stosb
    { checken, ob Ende des Zugriffsfensters... }
    or di, di
    jnz @patch06
    call move
    { zweite Schatten-Zeile zeichnen }
   @patch06:
    db 81h, 0c7h , 0 , 0		{ add di, .... }
    jnc @ok_d
    call move
   @ok_d:
    xor al, al
    mov cx, dx
    rep stosb
    { checken, ob Ende des Zugriffsfensters... }
    or di, di
    jnz @patch07
    call move
    { dritte Schatten-Zeile zeichnen }
   @patch07:
    db 81h, 0c7h , 0 , 0		{ add di, .... }
    jnc @ok_b
    call move
   @ok_b:
    xor al, al
    mov cx, dx
    rep stosb
    { checken, ob Ende des Zugriffsfensters... }
    or di, di
    jnz @ok_c
    call move
   @ok_c:




    @error:

end;

{ Zeichnet ein ausgeflltes Viereck ohne Rahmen }
procedure bar( x1 , y1 , x2 , y2 : word ; fillCol : byte ); assembler;
  asm
    { Absoluten Offset im Video-Ram berechnen...
      Wird in EDI abgelegt...
    }
    db 66h ; xor di, di			{ xor edi, edi }
    mov di, x1				{ mov di, x1 }
    db 66h ; xor ax, ax			{ xor eax, eax }
    mov ax, y1				{ mov ax, y1 }
    db 66h ; shl ax, 10d		{ shl eax, 10d }
    db 66h ; add di, ax			{ add edi, eax }

    { Zugriffsfenster auf das nchst kleinere 64k-Vielfache setzen...
      Wird in "windowStart" abgelegt ...
    }
    db 66h ; mov dx, di			{ mov edx, edi }
    db 66h ; shr dx, 16			{ shr edx, 16 }
    mov windowStart, dx
    mov ax, 4f05h
    xor bx, bx
    int 10h

    { ES auf das Fenster-Segment $a000 setzen... }

    mov ax, 0a000h
    mov es, ax

    { Anzahl Pixel pro Zeile berechnen...
      Wird in DX abgelegt...
    }
    mov dx, x2
    sub dx, x1
    inc dx
    mov bx, dx
    mov ax, dx
    shr bx, 2
    mov cs:word ptr @patch03+1, bx
    and ax, 3
    mov cs:word ptr @patch04+1, ax

    { Zeilensprung-Konstante berechnen... }
    mov ax, 1024
    sub ax, dx
    mov cs:word ptr @patch01+2, ax

    { Anzahl Y-Zeilen berechnen...
      Wird in BX abgelegt...
    }
    mov bx, y2
    sub bx, y1
    inc bx

    mov al, fillCol
    mov ah, fillCol
    db 66h ; shl ax, 16d
    mov al, fillCol
    mov ah, fillCol

    jmp @lineLoop


   @lineLoop:
   @patch03:
    db 0b9h, 0 , 0			{ mov cx, ... }
    db 66h ; rep stosw
   @patch04:
    db 0b9h, 0, 0			{ mov cx, ... }
    rep stosb

    { checken, ob Ende des Zugriffsfensters... }
    or di, di
    jnz @ok1
    call move
   @ok1:


   @patch01:
    db 81h, 0c7h , 0 , 0		{ add di, .... }
    jc @goMove
    dec bx
    jz @doneAll
    jmp @lineLoop
   @goMove:
    { Gre des Zugriffsfensters ist berschritten -> verschieben... }
    call move
    jmp @lineLoop

   @doneAll:
end;

Procedure SetCol(col, r, g, b:byte); Assembler;
asm
  mov dx, $3c8
  mov al, col
  out dx, al

  mov dx, $3c9
  mov al, r
  out dx, al

  mov al, g
  out dx, al

  mov al, b
  out dx, al
end;

procedure text ( x , y : word ; col : byte ; s : string );
begin
  asm
    { Absoluten Offset im Video-Ram berechnen...
      Wird in EDI abgelegt...
    }
    db 66h ; xor di, di			{ xor edi, edi }
    mov di, x				{ mov di, x1 }
    db 66h ; xor ax, ax			{ xor eax, eax }
    mov ax, y				{ mov ax, y1 }
    db 66h ; shl ax, 10d		{ shl eax, 10d }
    db 66h ; add di, ax			{ add edi, eax }

    { Zugriffsfenster auf das nchst kleinere 64k-Vielfache setzen...
      Wird in "windowStart" abgelegt ...
    }
    db 66h ; mov dx, di			{ mov edx, edi }
    db 66h ; shr dx, 16			{ shr edx, 16 }
    mov windowStart, dx
    mov ax, 4f05h
    xor bx, bx
    int 10h

    { ES auf das Fenster-Segment $a000 setzen... }

    mov ax, 0a000h
    mov es, ax

    { Jetzt beginnen, Font auszugeben... }
    mov dh, col
    push ds
    push bp

    { SS:BX auf den String... }
    lea  bx, [s]

    { Code-Patch resetten... }
    mov cs:byte ptr @patch01+3, 0

    { DS:SI auf den Bios-Font... }
    mov si, word ptr biosFont
    mov ds, word ptr biosFont+2

    { Loop fr die 14 Zeilen aller Buchstaben }
    mov cl, 14
  @loop0:
    push cx
    push di
    push bx

    { Stringlnge laden... }
    mov cl, byte ptr ss:[bx]
    inc bx

    { Jetzt kommt der Loop fr die n Buchstaben jeder Zeile... }
  @loop1:
    mov ch, 8
    mov al, byte ptr ss:[bx]
    inc bx
    mov dl, 14
    mul dl
    mov bp, ax
  @patch01:
    db 3eh, 8ah, 42h, 0                 { mov al, ds:[si+bp+...] }
  @loop2:
    rol  al, 1
    test al, 1
    jz @noPixel
    mov byte ptr es:[di], dh
  @noPixel:
    inc di
    dec ch
    jnz @loop2

    loop @loop1

    pop bx
    pop di
    add di, 1024
    inc cs:byte ptr @patch01+3
    pop cx
    loop @loop0

    pop bp
    pop ds
  end;
end;

procedure text3d ( x , y : word ; col1 : byte ; s : string );
begin
  asm
    { Absoluten Offset im Video-Ram berechnen...
      Wird in EDI abgelegt...
    }
    db 66h ; xor di, di			{ xor edi, edi }
    mov di, x				{ mov di, x1 }
    db 66h ; xor ax, ax			{ xor eax, eax }
    mov ax, y				{ mov ax, y1 }
    db 66h ; shl ax, 10d		{ shl eax, 10d }
    db 66h ; add di, ax			{ add edi, eax }

    { Zugriffsfenster auf das nchst kleinere 64k-Vielfache setzen...
      Wird in "windowStart" abgelegt ...
    }
    db 66h ; mov dx, di			{ mov edx, edi }
    db 66h ; shr dx, 16			{ shr edx, 16 }
    mov windowStart, dx
    mov ax, 4f05h
    xor bx, bx
    int 10h

    { ES auf das Fenster-Segment $a000 setzen... }

    mov ax, 0a000h
    mov es, ax

    { Jetzt beginnen, Font auszugeben... }
    mov dh, col1
    push ds
    push bp

    { SS:BX auf den String... }
    lea  bx, [s]

    { Code-Patch resetten... }
    mov cs:byte ptr @patch01+3, 0

    { DS:SI auf den Bios-Font... }
    mov si, word ptr biosFont
    mov ds, word ptr biosFont+2

    { Loop fr die 14 Zeilen aller Buchstaben }
    mov cl, 14
  @loop0:
    push cx
    push di
    push bx

    { Stringlnge laden... }
    mov cl, byte ptr ss:[bx]
    inc bx

    { Jetzt kommt der Loop fr die n Buchstaben jeder Zeile... }
  @loop1:
    mov ch, 8
    mov al, byte ptr ss:[bx]
    inc bx
    mov dl, 14
    mul dl
    mov bp, ax
  @patch01:
    db 3eh, 8ah, 42h, 0                 { mov al, ds:[si+bp+...] }
  @loop2:
    rol  al, 1
    test al, 1
    jz @noPixel
    mov byte ptr es:[di], dh

    mov word ptr es:[di+1024+1], 0
    mov byte ptr es:[di+1024+3], 0

    mov word ptr es:[di+2048+1], 0
    mov byte ptr es:[di+2048+3], 0

    mov word ptr es:[di+3072+1], 0
    mov byte ptr es:[di+3072+3], 0

    mov word ptr es:[di+4096+1], 0
    mov byte ptr es:[di+4096+3], 0
  @noPixel:
    inc di
    dec ch
    jnz @loop2

    loop @loop1

    pop bx
    pop di
    add di, 1024
    inc cs:byte ptr @patch01+3
    pop cx
    loop @loop0

    pop bp
    pop ds
  end;
end;

procedure drawWindow( x , y , length , height : word );
begin
  {setFillstyle ( 1 , 5 );
  bar ( x , y , x+length , y+height );

  setLineStyle ( 0 , 0 , 1 );
  setColor ( 15 );
  line( x , y , x+length , y );
  line( x , y , x , y+height );

  setColor ( 13 );
  line( x+length , y , x+length , y+height );
  line( x , y+height , x+length , y+height );

  setLineStyle ( 0 , 0 , 3 );
  setColor ( 0 ); line( x+3 , y+height+3 , x+length+3 , y+height+3 );
  setColor ( 0 ); line( x+length+2 , y+3 , x+length+2 , y+height+3 );}
end;

procedure drawBmpdata( x , y : word ; p : pointer ; nMem : byte );
begin
  asm
    { Code patchen... }
    mov al, nMem
    inc al
    shl ax, 4
    mov ah, al
    mov cs:word ptr @patch01+1, ax

    { Absoluten Offset im Video-Ram berechnen...
      Wird in EDI abgelegt...
    }
    db 66h ; xor di, di			{ xor edi, edi }
    mov di, x				{ mov di, x1 }
    db 66h ; xor ax, ax			{ xor eax, eax }
    mov ax, y		{ mov ax, y1 }
    db 66h ; shl ax, 10d		{ shl eax, 10d }
    db 66h ; add di, ax			{ add edi, eax }

    { Zugriffsfenster auf das nchst kleinere 64k-Vielfache setzen...
      Wird in "windowStart" abgelegt ...
    }
    db 66h ; mov dx, di			{ mov edx, edi }
    db 66h ; shr dx, 16			{ shr edx, 16 }
    mov windowStart, dx
    mov ax, 4f05h
    xor bx, bx
    int 10h

    { ES auf das Fenster-Segment $a000 setzen... }

    mov ax, 0a000h
    mov es, ax

    { Jetzt beginnen, Bitmap-Daten auszugeben... }
    { DS:SI auf den Puffer... }
    push ds
    mov si, ss:word ptr [p]
    mov ds, ss:word ptr [p+2]
    mov ch, 128
  @yLoop:
    mov cl, 64
  @xLoop:
    lodsb
    mov ah, al
  @patch01:
    db 05h, 0, 0                        { add ax, ... }
    mov word ptr es:[di], ax
    add di, 2
    dec cl
    jnz @xLoop
    add di, 1024-128
    { checken, ob Ende des Zugriffsfensters... }
    jnc @ok1
    call move
   @ok1:
    or dh, dh
    jnz @lb2
    inc dh
    sub si, 64
    jmp @lb3
  @lb2:
    xor dh, dh
  @lb3:

    dec ch
    jnz @yLoop



    pop  ds


  end;
end;

procedure readBmpData( bs : string ; nFile : word ; nMem : byte );
var f : file;
    i  : word;
    x : byte;
    y : byte;
    temp : array[0..(64*32-1)] of byte;
begin
    assign( f , bs );
    reset( f , 1 );

    seek( f , $36 );
    { Farbtabelle einlesen... }
    blockread( f , temp , 16*4 );
    for i := 0 to 15 do
    begin
      col[nMem][i,0]:=temp[i*4+2] div 4;
      col[nMem][i,1]:=temp[i*4+1] div 4;
      col[nMem][i,2]:=temp[i*4+0] div 4;
    end;

    blockread( f , temp , 64*32 );
    { jetzt die Bild-Daten sortieren... }
    for y := 0 to 63 do
    begin
      for x := 0 to 31 do
      begin
        pic[nMem][ (63-y)*64 +x*2+0] := temp[ y*32 + x] shr 4;
        pic[nMem][ (63-y)*64 +x*2+1] := temp[ y*32 + x] and $0f;
      end;
    end;
    close( f );
end;

procedure setBmpColours( nMem : byte );
var i : byte;
begin
  for i := 0 to 15 do
  begin
    setCol( (nMem+1)*16+i , col[nMem][i,0] , col[nMem][i,1] , col[nMem][i,2] );
  end;
end;

procedure bmpLoop;
var sr : searchRec;
    i  : byte;
begin
  findFirst( '*.BMP' , anyFile , sr );
  i := 0;
  while (dosError = 0) and (i<14) do
  begin
    readBmpdata( sr.name , 0 , i );
    findNext( sr );
    inc( i );
  end;
  for i := 0 to 6 do
  begin
    drawBmpData( 19+i*140 , 210 , @pic[i] , i );
    setBmpColours( i );
  end;
  for i := 7 to 13 do
  begin
    drawBmpData( 19+(i-7)*140 , 410 , @pic[i] , i );
    setBmpColours( i );
  end;

end;

procedure daSeg; assembler;
asm
  dw 0
end;

{$f+}
procedure mEvent; assembler;
asm
    pusha
    push es
    push ds

    mov ax, seg daseg
    mov ds, ax
    mov ds, word ptr ds:[daseg]

    { Maus wurde bewegt... }
    { Absoluten Offset im Video-Ram berechnen...
      Wird in EDI abgelegt...
    }
    db 66h ; xor di, di			{ xor edi, edi }
    mov di, cx				{ mov di, x1 }
    db 66h ; xor ax, ax			{ xor eax, eax }
    mov ax, dx		                { mov ax, y1 }
    db 66h ; shl ax, 10d		{ shl eax, 10d }
    db 66h ; add di, ax			{ add edi, eax }

    { Zugriffsfenster auf das nchst kleinere 64k-Vielfache setzen...
      Wird in "windowStart" abgelegt ...
    }
    db 66h ; mov dx, di			{ mov edx, edi }
    db 66h ; shr dx, 16			{ shr edx, 16 }
    mov windowStart, dx
    mov windowStart2, dx
    mov ax, 4f05h
    xor bx, bx
    int 10h

    push di

    { DS auf das Fenster-Segment $a000 setzen... }

    mov  ax, ds
    mov  es, ax
    mov  ax, 0a000h
    mov  ds, ax

    { Diesen Bildschirminhalt sichern... }

    {mov si, di
    mov bl, 8
    mov di, offset mScreen
  @yLoop2:
    mov cx, 8
    rep movsb
    add si, 1024-8
    jnc @ok_b
    pusha
    inc windowStart
    mov dx, windowStart
    mov ax, 4f05h
    xor bx, bx
    int 10h
    popa
  @ok_b:
    dec bl
    jnz @yLoop2}

    { Zugriffsfenster auf das nchst kleinere 64k-Vielfache setzen...
      Wird in "windowStart" abgelegt ...
    }
    mov dx, windowStart2
    mov windowStart, dx
    mov ax, 4f05h
    xor bx, bx
    int 10h

    pop di


    { ES auf das Fenster-Segment $a000 setzen... }

    mov ax, es
    mov ds, ax
    mov ax, 0a000h
    mov es, ax

    { Mauszeiger draufkopieren... }
    mov ch, 8
    mov si, offset mBitmap
  @yLoop:
    mov cl, 8
    lodsb
  @xLoop:
    rol al, 1
    test al, 1
    jz @noPixel
    mov byte ptr es:[di], 15
  @noPixel:
    inc di
    dec cl
    jnz @xLoop
    add di, 1024-8
    jnc @ok_a
    pusha
    inc windowStart
    mov dx, windowStart
    mov ax, 4f05h
    xor bx, bx
    int 10h
    popa
  @ok_a:
    dec ch
    jnz @yLoop



    mov al, 15
    stosb

  @lb1:
    pop ds
    pop es
    popa
end;
{$f-}



procedure initProc;
var i : word;
begin
  asm

    { Bildschirm lschen... }
    mov ax, 3
    int 10h

    { berprfen, ob VESA-BIOS vorhanden ist... }
    mov  ax, 4f00h
    push ds
    pop  es
    mov  di, offset vesaInfo
    int  10h

  end;
  if char(vesaInfo.sig[0]) + char(vesaInfo.sig[1]) + char(vesaInfo.sig[2]) + char(vesaInfo.sig[3]) = 'VESA' then
    begin
      writeln('VESA-BIOS ver ',vesaInfo.highVer,'.',vesaInfo.lowVer,' found...');
    end
   else
    begin
      writeln('VESA-support required...');
      halt;
    end;

  { berprfen, ob 1024*768*256 untersttzt wird... }
  asm
    mov vesa105, 0
    les di, vesaInfo.modes
  @loop1:
    cmp word ptr es:[di], 105h
    je @foundVesaMode
    cmp word ptr es:[di], 0ffffh
    je @notFound
    add di, 2
    jmp @loop1
  @foundVesaMode:
    mov vesa105, 1
  @notFound:
  end;
  if vesa105 then
   begin
     writeln('VESA-MODE 105h [1024*768*256] supported...');
   end
  else
   begin
     writeln('VESA-MODE 105h [1024*768*256] not supported...');
     halt;
   end;

  { Infos ber 1024*768*256 einholen... }
  asm
    mov  ax, 4f01h			{ Infos ber Modus holen }
    mov  cx, 105h			{ 1024*768*256 }
    push ds
    pop  es
    mov  di, offset modeInfo
    int  10h
  end;

  { checken, ob Monitor den Modus vetrgt... }
  if modeInfo.modeFlag and 1 = 1 then
   begin
     writeln('Display o.k...');
   end
  else
   begin
     writeln('Display does not support VESA-mode 105h [1024*768*256]...');
     halt;
   end;

  { Das erste Zugriffsfenster checken... }
  if modeInfo.winFlag1 and 1 = 1 then
   begin
     writeln('first window available...');
   end
  else
   begin
     writeln('first window not available...');
     halt
   end;
  if modeInfo.winFlag1 and 4 = 4 then
   begin
     writeln('first window write-capable...');
   end
  else
   begin
     writeln('first window not write-capable...');
     halt
   end;

  if modeInfo.winSize <> 64 then
  begin
    writeln('window size <> 64 kB...');
    halt;
  end;

  { In den 1024*768*256 Modus schalten }
  writeln('switching to 1024*768*256...');
  asm
    mov ax, 4f02h
    mov bx, 105h
    int 10h
  end;

  { Pointer auf Bios-Font ermitteln...
    in "BiosFont" ablegen...
  }
  asm
    push bp
    mov ax, 1130h
    mov bh, 2
    int 10h
    mov ax, bp
    pop bp
    mov ds:word ptr biosFont, ax
    mov ds:word ptr biosFont+2, es
  end;

  { Farben umdefinieren... }
  setCol( 1 , 0 , 0 , 15 );
  setCol( 5 , 20 , 0 , 20 );

  { Bildschirm blau fllen }
  bar ( 0 , 0 , 1023 , 767 , 1 );

  { Box ausgeben }
  box ( 10 , 10 , 1023-10 , 40 , 15 , 13 , 5 );

  for i := 0 to 6 do box (18 + i*140 , 200 , 18 + 135 +i*140 , 350 , 15 , 8 , 7 );
  for i := 0 to 6 do box (18 + i*140 , 400 , 18 + 135 +i*140 , 550 , 15 , 8 , 7 );

  text3d( 28 , 18 , 15 , 'iPeg rev '+rev);
  text3d( 850 , 18 , 15 , '(c) Falcon / iCode');

  box ( 10 , 730 , 1023-10 , 760 , 15 , 13 , 5 );
  text3d( 28 , 737 , 15 , 'alt-x -> eXit');

  asm
    { Maus initialisieren... }
    xor ax, ax
    int 33h
    { eigenen Event-Handler... }
    mov ax, 000ch
    mov cx, 11111b
    push seg mEvent
    pop  es
    mov  dx, offset mEvent
    int  33h
    push seg daseg
    pop  es
    mov ax, ds
    mov es:word ptr daseg, ax
  end;
end;

procedure closeProc;
begin
  { wieder in Textmodus schalten }
  asm
    mov ax, 3
    int 10h
  end;
end;

begin

  initProc;

  bmpLoop;
  repeat; until keyPressed;

  closeProc;

end.