uses dos,crt;

const
  zoom : array[0..31] of word = (2,4,8,16,32,64,128,256,512,768,1024,1280,1536,1792,2048,2304,2560,
                                 2304,2048,1792,1536,1280,1024,768,512,256,128,64,32,16,8,4);

type
  scrn     = array[0..65534] of byte;

var
  pic       : array[0..127,0..255] of byte;
  sinus     : array[0..255] of integer;
  scr       : ^scrn;
  x,y       : integer;
  page      : byte;
  xqd,yqd   : word;
  f1i,f2i   : word;

  colortable : array[0..31] of byte;
  colorarr   : array[0..200,1..3] of byte;
  tableofs   : word;
  colorofs   : word;
  color      : byte;
  c1,c2,c3   : byte;
  r1,r2,r3   : byte;

{$L v3220pa}                               { Assembler-Modul einbinden }

procedure init320200; external;
procedure showpage( page : byte ); external;

{$L s256x128.obj}
procedure skull_bitmap; external;

procedure initcolors;
var
  regs : registers;
  rgb  : array[0..255,1..3] of byte;
  a    : byte;
begin
  for a:=0 to 255 do
    begin
    rgb[a,1]:=0;
    rgb[a,2]:=0;
    rgb[a,3]:=0;
    end;
  regs.ah:=$10;
  regs.al:=$12;
  regs.bx:=0;
  regs.cx:=256;
  regs.es:=seg(rgb);
  regs.dx:=ofs(rgb);
  intr($10,regs);
end;

procedure initcolortable;
var
  a : byte;
begin
  for a:=0 to 15 do
    begin
    colortable[a]:=a*4;
    colortable[31-a]:=a*4;
    end;
  for a:=0 to 200 do
    begin
    colorarr[a,1]:=0;
    colorarr[a,2]:=0;
    colorarr[a,3]:=0;
    end;
  tableofs:=ofs(colortable);
  colorofs:=ofs(colorarr);
end;

procedure dopal(c1,c2,c3 : byte); assembler;
asm
  cld
  mov  ax,ds        { Datensegmente stets gleich! }
  mov  es,ax

  xor  ah,ah
  mov  al,c1
  mov  bx,ax
  add  bx,ax
  add  bx,ax        { Index mit 3 multiplizieren }
  add  bx,colorofs  { Ofsett zur Tabelle }
  mov  di,bx        { ES:DI auf Ziel }
  mov  si,tableofs  { DS:SI auf Quelle }
  xor  cx,cx        { Zhler }
@schleife1:
  movsb             { kopieren }
  inc  di
  inc  di
  inc  cl
  cmp  cl,32
  jne  @schleife1

  xor  ah,ah
  mov  al,c2
  mov  bx,ax
  add  bx,ax
  add  bx,ax        { Index mit 3 multiplizieren }
  add  bx,colorofs  { Ofsett zur Tabelle }
  inc  bx
  mov  di,bx        { ES:DI auf Ziel }
  mov  si,tableofs  { DS:SI auf Quelle }
  xor  cx,cx        { Zhler }
@schleife2:
  movsb             { kopieren }
  inc  di
  inc  di
  inc  cl
  cmp  cl,32
  jne  @schleife2

  xor  ah,ah
  mov  al,c3
  mov  bx,ax
  add  bx,ax
  add  bx,ax        { Index mit 3 multiplizieren }
  add  bx,colorofs  { Ofsett zur Tabelle }
  add  bx,2
  mov  di,bx        { ES:DI auf Ziel }
  mov  si,tableofs  { DS:SI auf Quelle }
  xor  cx,cx        { Zhler }
@schleife3:
  movsb             { kopieren }
  inc  di
  inc  di
  inc  cl
  cmp  cl,32
  jne  @schleife3
end;

procedure drawpal; assembler;
asm
  mov  dx,3c8h
  mov  al,0
  out  dx,al        { Startfarbe setzen }

  mov  cx,600
  mov  si,colorofs

@schleife:
  mov  dx,$3da
@write:
  in   al,dx
  and  al,00001000b
  cmp  al,00001000b
  je   @write
@back:
  in   al,dx
  and  al,00001000b
  cmp  al,00000000b
  je   @back

  mov  dx,$3c9

@weiter:
  rep  outsb

end;

procedure copyscreen(page:byte); assembler;
asm
  push ds

  mov  al,page
  cmp  al,0
  jne  @weiter1
  xor  bx,bx
  jmp  @fertig
@weiter1:
  cmp  al,1
  mov  bx,65536/4
@fertig:

  mov  ax,0A000h
  mov  es,ax        { ES auf Videosegment }
  cld

  mov  ah,3         { Pixel 1 und 2... }
  mov  al,2         { nach AL die Registernummer }
  mov  dx,03C4h     { Indexadresse des Sequencers laden }
  out  dx,ax        { Bit-Mask-Register laden }
  mov  di,bx
  lds  si,scr
  add  si,80

  mov  cx,2000
  db   0F3h,066h,0A5h { rep movsd }

  mov  ah,12        { Pixel 3 und 4 }
  out  dx,ax        { Bit-Mask-Register laden }
  mov  di,bx
  add  si,80
  mov  cx,2000
  db   0F3h,066h,0A5h { rep movsd }

  pop  ds
end;

procedure initsinus;
var
  w : word;
begin
  for w:=0 to 255 do sinus[w]:=round(sin(w*pi/128)*256);
end;

procedure dirozoom(w : byte;zf : word); assembler;
asm
  cli
  mov  al,80h   { Interrupts unterdrcken }
  out  70h,al

  mov  si,offset sinus
  mov  bl,w
  xor  bh,bh
  shl  bx,1
  mov  ax,ds:[si+bx]
  db   066h,033h,0c9h         { xor ecx,ecx }
  mov  cx,zf
  db   066h,098h              { cwde }
  db   066h,00fh,0afh,0c1h    { imul eax,ecx }
  db   066h,0c1h,0e8h,008h    { shr eax,8 }
  mov  dx,ax                  { F1I }
  mov  word ptr cs:@patch_ax+1,ax
  mov  word ptr cs:@patcher_ax+1,ax
  mov  word ptr cs:@patch_dx2+5,ax

  add  bx,128
  and  bh,00000001b
  mov  ax,ds:[si+bx]
  db   066h,098h              { cwde }
  db   066h,00fh,0afh,0c1h    { imul eax,ecx }
  db   066h,0c1h,0e8h,008h    { shr eax,8 }
  mov  word ptr cs:@patch_dx+2,ax   { F2I }
  mov  word ptr cs:@patcher_dx+2,ax
  mov  word ptr cs:@patch_ax2+5,ax

  mov  bx,ax
  shl  bx,4
  mov  cx,ax
  shl  cx,5
  add  bx,cx
  mov  cx,dx
  shl  cx,6
  add  bx,cx
  not  bx
  mov  word ptr cs:@patch_ax3+1,bx

  shl  ax,6
  mov  cx,dx
  shl  cx,4
  sub  ax,cx
  shl  dx,5
  sub  ax,dx
  not  ax
  mov  dx,ax
  mov  word ptr cs:@patch_dx3+1,ax


  cld
  push bp
  mov  ax,offset pic
  mov  word ptr cs:@xschleife+1,ax
  mov  word ptr cs:@patcher+1,ax
  les  di,scr

  mov  ax,bx
  xor  bh,bh
@yschleife:
  mov  cl,80

@patch_ax2:
  add  word ptr cs:@patch_ax3+1,1234h
@patch_dx2:
  sub  word ptr cs:@patch_dx3+1,1234h

  xor  bp,bp
@xschleife:
  mov  si,0     { wird modifiziert }
  mov  bl,ah

  mov  bh,dh
  and  bh,127

  mov  bl,[si+bx]
  xor  bh,bh
  add  bx,bp
  add  bx,bp
  add  bx,bp
  mov  bp,es:[di]
  shr  bp,8
  add  bx,bp
  mov  bp,es:[di+80]
  shr  bp,8
  add  bx,bp
  add  bx,bp
  add  bx,bp
  shr  bx,3
  mov  bp,bx
  mov  es:[di+80],bl

@patch_dx:
  add  dx,1234h
@patch_ax:
  add  ax,1234h

@patcher:
  mov  si,0     { wird modifiziert }
  mov  bl,ah

  mov  bh,dh
  and  bh,127

  mov  bl,[si+bx]
  xor  bh,bh
  add  bx,bp
  add  bx,bp
  add  bx,bp
  mov  bp,es:[di+8080]
  shr  bp,8
  add  bx,bp
  mov  bp,es:[di+8160]
  shr  bp,8
  add  bx,bp
  add  bx,bp
  add  bx,bp
  shr  bx,3
  mov  bp,bx
  mov  es:[di+8160],bl

  inc  di

@patcher_dx:
  add  dx,1234h
@patcher_ax:
  add  ax,1234h

  dec  cl
  jnz  @xschleife

@patch_ax3:
  mov  ax,1234h
@patch_dx3:
    mov  dx,1234h

  add  word ptr cs:@patch_ax2+5,2
  add  word ptr cs:@patch_dx2+5,2
{}
  cmp  di,8000
  jb   @yschleife

  pop  bp
  mov  al,00h   { Interrupts wieder zulassen }
  out  70h,al
  sti
end;

procedure loadbmp;
type
  bild    = array[0..1000] of byte;
  picture = array[0..127,0..255] of byte;
var
  dac  : array[0..255,0..2] of byte;
  rgb  : array[0..3] of byte;
  buf  : array[0..320] of byte;
  bld  : ^bild;
  pic2 : ^picture;
  a,b  : word;
  regs : registers;
begin
  bld:=@skull_bitmap;
  a:=$36;
  for y:=0 to 255 do
  begin
    move(bld^[a],rgb,4);
    inc(a,4);
    dac[y,0]:=y div 4;
    dac[y,1]:=y div 12;
    dac[y,2]:=y div 12;
  end;
  regs.ah:=$10;
  regs.al:=$12;
  regs.bx:=0;
  regs.cx:=256;
  regs.es:=seg(dac);
  regs.dx:=ofs(dac);
  intr($10,regs);
  pic2:=@bld^[a];
  for a:=0 to 127 do
    for b:=0 to 255 do pic[(a+48) mod 128,(b+190) mod 256]:=pic2^[a,b];
end;

var
  w    : byte;
  zf   : word;
begin
  initsinus;
  init320200;

  { Verdoppelung der Zeilen!!! }
  port[$3D4]:=9;
  port[$3D5]:=port[$3D5] and $80+3;

  loadbmp;
  getmem(scr,sizeof(scrn));
  fillchar(scr^,sizeof(scrn),0);

  w:=0;
  x:=1;

  page:=0;
  zf:=0;

  initcolors;
  initcolortable;
  c1:=100; c2:=0; c3:=50;
  r1:=0; r2:=0; r3:=0;
  repeat
  dirozoom(w,zf);
  asm
    add  w,4
    add  zf,1
  end;
  showpage(page);
  asm
    mov  al,1
    sub  al,page
    mov  page,al
  end;
  copyscreen(page);
    dopal(c1,c2,c3);
    drawpal;

    if (r1=0) and (c1<168) then inc(c1);
    if (r1=0) and (c1=168) then r1:=1;
    if (r1=1) and (c1>0) then dec(c1);
    if (r1=1) and (c1=0) then r1:=0;

    if (r2=0) and (c2<168) then inc(c2);
    if (r2=0) and (c2=168) then r2:=1;
    if (r2=1) and (c2>0) then dec(c2);
    if (r2=1) and (c2=0) then r2:=0;

    if (r3=0) and (c3<168) then inc(c3);
    if (r3=0) and (c3=168) then r3:=1;
    if (r3=1) and (c3>0) then dec(c3);
    if (r3=1) and (c3=0) then r3:=0;
  until (zf>=544) or keypressed;
  zf:=8;
  repeat
  dirozoom(w,zoom[zf]+32);
  zf:=(zf+1) and 31;
  asm
    add  w,4
  end;
  showpage(page);
  asm
    mov  al,1
    sub  al,page
    mov  page,al
  end;
  copyscreen(page);
    dopal(c1,c2,c3);
    drawpal;

    if (r1=0) and (c1<168) then inc(c1);
    if (r1=0) and (c1=168) then r1:=1;
    if (r1=1) and (c1>0) then dec(c1);
    if (r1=1) and (c1=0) then r1:=0;

    if (r2=0) and (c2<168) then inc(c2);
    if (r2=0) and (c2=168) then r2:=1;
    if (r2=1) and (c2>0) then dec(c2);
    if (r2=1) and (c2=0) then r2:=0;

    if (r3=0) and (c3<168) then inc(c3);
    if (r3=0) and (c3=168) then r3:=1;
    if (r3=1) and (c3>0) then dec(c3);
    if (r3=1) and (c3=0) then r3:=0;
  until keypressed;
  freemem(scr,sizeof(scrn));

  textmode(co80);
end.