{$m 30000, 50000, 50000 }

unit get_dir;

interface
  procedure init_getdir(me, se, s, f, a : pointer);
  {Pointer auf die Variablen max_entry, scroll_entry, size, files,
   type_of_archive }
  Procedure Get_directory;

implementation

uses dos;

type
  file_type     =       record
                          name   : string[12];   { file name }
                          suf    : string[3];    { file suffix }
                          attrib : word;         { file attrib }
                          date   : datetime;     { file date and time }
                          p_size : longint;      { packed size }
                          u_size : longint;      { unpacked size }
                          to_cont: boolean;      { volume: file to be continued ? }
                          cont   : boolean;      { volume: file began elsewhere ? }
                          dirnbr : word;         { fictive directory number of archived file }
                        end;

  xy            =       array [0..511] of file_type;

var
  max_entry     :       ^integer;
  scroll_entry  :       ^integer;
  size          :       ^longint;
  files         :       ^xy;
  type_of_archive:      ^byte;

procedure init_getdir(me, se, s, f, a : pointer);
begin;
  max_entry:=me;
  scroll_entry:=se;
  size:=s;
  type_of_archive:=a;
  files:=f;
end;

Procedure Get_directory;
label read_file_entrys;
label end_of_procedure;
var
  direntry      :       searchrec;
  i             :       longint;
  i2            :       longint;
begin;
  type_of_archive^:=0;
  max_entry^:=0;
  scroll_entry^:=0;
  size^:=0;
  { only directories }
  findfirst('*.*', $10, direntry);
  repeat;
    if direntry.attr and $10 <> 0 then
      if direntry.name <> '.' then begin;
        files^[max_entry^].name:=direntry.name;
        files^[max_entry^].attrib:=direntry.attr;
        unpacktime(direntry.time,files^[max_entry^].date);
        inc(max_entry^);
    end;
    findnext(direntry);
    if doserror<>0 then goto read_file_entrys;
  until i=512;

  read_file_entrys:
  { now all the files }
  findfirst('*.*', $27, direntry);
  if doserror<>0 then goto end_of_procedure;
  files^[max_entry^].name:=direntry.name;
  files^[max_entry^].attrib:=direntry.attr;
  unpacktime(direntry.time,files^[max_entry^].date);
  files^[max_entry^].u_size:=direntry.size;
  inc(size, direntry.size);
  inc(max_entry^);
  repeat;
    findnext(direntry);
    if doserror<>0 then goto end_of_procedure;
    files^[max_entry^].attrib:=direntry.attr;
    files^[max_entry^].name:=direntry.name;
    unpacktime(direntry.time,files^[max_entry^].date);
    files^[max_entry^].u_size:=direntry.size;
    inc(size, direntry.size);
    inc(max_entry^);
  until max_entry^=512;

  end_of_procedure:
  { No Capital file names...}
  for i:=0 to max_entry^ do begin;
    if files^[i].attrib and $10 = 0 then for i2:=1 to length(files^[i].name) do
      if ord(files^[i].name[i2])>$40 then
        if ord(files^[i].name[i2])<$5b then
          files^[i].name[i2]:=chr(ord(files^[i].name[i2])+$20);
  end;
  { Splitting up into name and suffix... }
  for i:=0 to max_entry^ do begin;
    if files^[i].name[1]<>'.' then begin;
      i2:=1;
      repeat;
        if files^[i].name[i2]='.' then begin;
          files^[i].suf:=copy(files^[i].name,i2+1,length(files^[i].name)-1);
          files^[i].name:=copy(files^[i].name,1,i2-1);
        end;
        inc(i2);
      until((i2>length(files^[i].name))or(files^[i].name[i2-1]='.'));
      if files^[i].name[i2-1]<>'.' then files^[i].suf:='';
    end;
  end;
  if max_entry^ < 56 then for i:=max_entry^ to 56 do begin;
    files^[i].name:='';
    files^[i].suf:='';
  end;
end;


end.