{$N+,E-}

uses crt;

const
  bmpfile : string = 'tunnel.bmp';
  r       = 1;
  d       = 1;
  xadd    = 7;
  yadd    = 250;

type
  bldarr = array[0..63999] of byte;

var
  time   : word;
  bmp    : pointer;
  scr    : pointer;
  dac    : array[0..255,0..2] of byte;
  x,y    : integer;
  f      : file;
  buf    : array[0..255] of byte;
  ang    : ^bldarr;
  wid    : ^bldarr;
  a      : byte;
  ar     : single;
  w      : byte;
  pos    : word;
  xa     : byte;
  ya     : byte;
  bpos   : word;
  page   : byte;
  sintab : array[0..255] of integer;

procedure initgraph; assembler;
asm
  mov  ax,13h
  int  10h
end;

procedure copyscreen(page:byte); assembler;
asm
  push ds

  mov  al,page
  cmp  al,0
  jne  @weiter1
  xor  bx,bx
  jmp  @fertig
@weiter1:
  cmp  al,1
  jne  @weiter2
  mov  bx,65536/4
  jmp  @fertig
@weiter2:
  cmp  al,2
  jne  @weiter3
  mov  bx,65536/2
  jmp  @fertig
@weiter3:
  mov  bx,65536/4*2
@fertig:

  mov  ax,0A000h
  mov  es,ax        { ES auf Videosegment }
  mov  ds,word ptr scr+2
  cld

  mov  ah,1         { Pixel 0,4,8... }
  mov  al,2         { nach AL die Registernummer }
  mov  dx,03C4h     { Indexadresse des Sequencers laden }
  out  dx,ax        { Bit-Mask-Register laden }
  mov  cx,320*200/4 { Gre einer Plane }
  mov  di,bx
  xor  si,si
@loop1:
  movsb
  add  si,3
  loop @loop1

  mov  ah,4         { Pixel 0,4,8... }
  out  dx,ax        { Bit-Mask-Register laden }
  mov  cx,320*200/4 { Gre einer Plane }
  mov  di,bx
  mov  si,2
@loop3:
  movsb
  add  si,3
  loop @loop3

  mov  ah,2         { Pixel 0,4,8... }
  out  dx,ax        { Bit-Mask-Register laden }
  mov  cx,320*200/4 { Gre einer Plane }
  mov  di,bx
  mov  si,1
@loop2:
  movsb
  add  si,3
  loop @loop2

  mov  ah,8         { Pixel 0,4,8... }
  out  dx,ax        { Bit-Mask-Register laden }
  mov  cx,320*200/4 { Gre einer Plane }
  mov  di,bx
  mov  si,3
@loop4:
  movsb
  add  si,3
  loop @loop4

  pop  ds
end;

procedure loadbitmap;
var
  y   : byte;
begin
  assign(f,bmpfile);
  reset(f,1);
  seek(f,$36);
  for y:=0 to 255 do
    begin
    blockread(f,buf,4);
    dac[y,0]:=buf[2] div 4;
    dac[y,1]:=buf[1] div 4;
    dac[y,2]:=buf[0] div 4;
    end;
  for y:=0 to 255 do
    begin
    blockread(f,buf,256);
    asm
      mov  es,word ptr bmp+2
      mov  bh,255
      sub  bh,y
      xor  bl,bl
      mov  di,bx
      mov  si,offset buf
      mov  cx,128
      rep  movsw
    end;
    end;
  close(f);
  asm
    mov  ax,seg dac
    mov  es,ax
    mov  dx,offset dac
    mov  ah,10h
    mov  al,12h
    xor  bx,bx
    mov  cx,256
    int  10h
  end;
end;

procedure draw;
begin
asm
  mov dx,$3da
  @x: in al, dx
      test al, 08h
      jnz @x
  @y: in al, dx
    test al, 08h
    jz @y

    push bp                             { fALCON: Borland requires thiz }
    push ds

    mov ax, 0A000h
    mov es, ax                          { fALCON: faster then pushing }
    mov di, 140*320                     { fALCON: lower part of screen }
    xor al, al
    mov ah, byte ptr time+1
    mov cs:word ptr @patch01+1, ax
    mov cs:word ptr @patch02+2, 100h    { fALCON: reset patch }

    mov si, word ptr bmp
    mov ds, word ptr bmp+2              { fALCON: DS:SI @BMP }


    mov cx, cs:word ptr @patch01+1
    mov dl, 60                          { fALCON: y-counter }
  @yLoop:
    mov bl, ah
    mov bp, 320                         { fALCON: xcounter }
  @xLoop:
    mov bl, ch

    mov al, [si+bx]                     { fALCON: load pixeldata }
    mov es:[di], al                     { fALCON: write to screen }
    inc di                              { fALCON: next pixel }

  @patch02:
    add cx, 1234h

    dec bp
    jnz @xLoop
    add si, 256+2

  @patch01:
    mov cx, 1234h
    sub cs:word ptr @patch02+2, 4

    dec dl
    jnz @yLoop


    pop ds
    pop bp
  end;
end;

begin
  if paramcount<>0 then bmpfile:=paramstr(1);
  asm
    mov ax, 13h
    int 10h
  end;
  getmem( bmp , $ffff );

  loadbitmap;

  repeat;
    draw;
    asm
      inc byte ptr time+1
    end;
  until keyPressed;

  freemem( bmp , $ffff );

  asm
    mov ax, 3
    int 10h
  end;
end.
