{ Programm sol den aperiodischen Kriechfall bei Pendel verdeutlichen.
  Allgemeingltig fr gedmpfte Schwinger - m. klossek }

program kriechFall;

uses crt, textwin, mouse, graph;

var U0, Z        : real;
    R            : real;
    L, C         : real;
    delta, omega : real;
    komplex      : boolean;
    xadd         : integer;     { xaddi -> for seperation }
    zf, sf, rf   : real;        { Zoom- and stretchfaktor }

    x, rc   : integer;
    y,yo    : integer;
    sysDone : boolean;
    ch      : char;
    intC    : byte;
    intern  : boolean;
    gd,gm   : integer;
    lineM   : boolean;
    autoMode: boolean;
    showPage: byte;

{ Stromstrke nach Omega - Funktion fr Impedanz }
function I ( omega : real ) : real;
begin
     Z := sqrt ( R*R + sqr ( omega * L - 1 / (omega * C) ) );
     I := U0 / Z;
end;

{ eigentliche Spannungsfunktion bei gedmpften Pendel }
function sinU ( t : real ) : real;
begin
     sinU := U0 * exp ( - delta * t ) * sin ( omega * t);
end;

{ lscht den Bildschirm }
procedure clrScreen; assembler;
asm
   mov ax,0a000h
   mov es,ax
   xor di,di

   cld
   mov ax,0
   mov cx,32000
   rep stosw
end;

{ Zeichnet die Funktion sinU im Intervall [0..2pi] inklusive Punktverb.
  -> mit bgi-Treiber }
procedure plotFuncX (col : boolean);
var  drawColor : byte;
     maxY      : word;
begin
     IF col THEN drawColor := intC ELSE drawColor := 0;

     maxY := getMaxY;
     yo := maxY SHR 1; { Startwert }

     setColor (drawColor);
     for x := 0 to getMaxX-1 do
      begin
           { xadd ist der Verschiebungsparameter fr die linke Seite }
           { zf ist der Zoomfaktor }

           y := -round ( sinU (  (x + xadd) * zf ) * sf ) + (maxY SHR 1);

           IF y < 5 THEN y := 5;
           IF y > maxY-5 THEN y := maxY-5;

           IF lineM THEN line (x, yo, x+1,y)
           ELSE putPixel (x,y, drawColor);

           yo := y;
      end;
end;

{ Zeichnet die Funktion sinU im Intervall [0..2pi] inklusive Punktverb. }
procedure plotFunc ( col : boolean );
var  drawColor : byte;
     y         : integer;
begin
     IF not intern THEN BEGIN plotFuncX ( col ); exit; END;
     IF col THEN drawColor := intC ELSE drawColor := 0;

     yo := 100; { Startwert }

     for x := 0 to 319 do
      begin
           { xadd ist der Verschiebungsparameter fr die linke Seite }
           { zf ist der Zoomfaktor }

           y := -round ( sinU (  (x + xadd) * zf ) * sf ) + 100;
           { y := round ( sin ( x / 5 ) * 50 ) + 100; }
           IF y < 5 THEN y := 10;
           IF y > 195 THEN y := 195;

           asm
              mov ax,0a000h
              mov es,ax

              mov ax,yo
              mov bx,320
              mul bx
              add ax,x
              mov di,ax         { y_old in di }

              mov ax,y
              mul bx
              add ax,x
              mov si,ax         { y_act in si }
              mov al,drawColor

              cmp si,di
              ja  @decI
              je  @not

            @cont1:
              sub di,320
              mov byte ptr es:[di],al
              cmp di,si
              jne @cont1

            @decI:
            @cont2:
              add di,320
              mov byte ptr es:[di],al
              cmp di,si
              jb @cont2

            @not:
              mov byte ptr es:[si],al

           end;
           yo := y;
      end;
end;

{ Berechnet die Konstanten neu }
procedure reCalc;
var  radikant : real;
begin
     delta := R / ( 2 * L );
     radikant := 1 / ( L*C )  -  delta * delta ;

     IF radikant < 0 THEN
      BEGIN
           komplex := true; intC := 12;
           radikant := radikant * (-1); { merke -1 -> mal sehen, was sich }
      END                               { damit anfangen lt... }
     ELSE BEGIN komplex := false; intC := 14; END;

     omega := sqrt ( radikant );
end;

{ Ausgabe der Werte und Abfrage bei Programmstart / Erluterungen }
procedure userRequest;
label resCalc;
var  reqDone : boolean;

 procedure txtOut ( which : byte; inp : boolean );
 begin
      CASE which OF
      1: { L }
       IF inp THEN
        BEGIN
        END
       ELSE
        BEGIN
             gotoxy ( 30, 5 );
             write ( L, ' H ');
        END;
      2: { C }
       IF inp THEN
        BEGIN
        END
       ELSE
        BEGIN
             gotoxy ( 30, 6 );
             write ( C, ' F ');
        END;
      3: { U0 }
       IF inp THEN
        BEGIN
        END
       ELSE
        BEGIN
             gotoxy ( 30, 7 );
             write ( U0, ' V ');
        END;
      4: { R }
       IF inp THEN
        BEGIN
        END
       ELSE
        BEGIN
             gotoxy ( 30, 8 );
             write ( R, '  ');
        END;
      END;
 end;

begin
     asm mov ax,0003h; int 10h; end;
     SetC (11,1);
     clrScr;

     gotoxy (2,2);
     write ('  Pendel- und Bereichsdaten');
     gotoxy (2,3);
     write ('');
     gotoxy (2,24);
     write ('  Bitte ESC zum Plotten drcken.');

   resCalc:
     SetC (7,1);
     gotoxy (4,5);
     write (' - Induktivitt L       = ');   txtOut (1, false);
     gotoxy (4,6);
     write (' - Kapazitt C          = ');   txtOut (2, false);
     gotoxy (4,7);
     write (' - Scheitelspannung U0  = ');   txtOut (3, false);
     gotoxy (4,8);
     write (' - Widerstand           = ');   txtOut (4, false);
     gotoxy (4,10);
     write ('-> delta  = ',round (delta*1000),' / 1000 ');
     gotoxy (40,10);
     write ('-> omega0 w0 = ',round ( sqrt (1 / (L*C)) *1000 ) ,' / 1000 ' );
     gotoxy (4,11);
     write ('-> omega w = ',round (omega*1000 ) ,' / 1000 ' );

     reqDone:=false;
     REPEAT
           IF keyPressed THEN
            BEGIN
                 ch := readkey;

                 CASE ch OF
                 #27,#32: reqDone := true;
                 '+': { inc Widerstand }
                  BEGIN
                       R := R + rf;
                       reCalc;
                       goto resCalc;
                  END;
                 '-': { dec Widerstand }
                  BEGIN
                       R := R - rf;
                       reCalc;
                       goto resCalc;
                  END;
                 END;
            END;
     UNTIL reqDone;
end;

{ gibt grundstzliche Anweisungen }
procedure userInfo;
begin
     asm mov ax,0003h; int 10h; end;
     SetC ( 11,1 );
     clrScr;

     gotoxy (2,2);
     write ('  Untersuchung des Schwingungsverhalten bei gedmpften Pendeln.');
     gotoxy (2,3);
     write ('');
     SetC ( 7, 1);
     gotoxy (2,5);
     write (' Das Programm zeichnet einen Graphen der Funktion :');
     gotoxy (10,7);
     write ('           - * t');
     gotoxy (10,8);
     write (' U = U0 * e     *  sin ( w * t )');
     gotoxy (2,9);
     write ('                                   _______________');
     gotoxy (2,10);
     write (' mit   = R / ( 2 * L )  und  w =  w0^2  -  ^2');

     SetC ( 11,1 );
     gotoxy (2,13);
     write ('  Bedienungshinweise');
     gotoxy (2,14);
     write ('');

     SetC ( 7,1 );
     gotoxy (2,16);
     write (' Mit den +/- Tasten kann der ohmsche Widerstand, also der Grad der');
     gotoxy (2,17);
     write (' Dmpfung (analog zu C), in Schritten von 0.01 verndert werden. In den');
     gotoxy (2,18);
     write (' Auschnitt kann mit den Oben/Unten-Tasten hinein- bzw. herausgezoomt');
     gotoxy (2,19);
     write (' werden. Die Rechts/Links-Tasten bewirken eine Verschiebung des sichtbaren');
     gotoxy (2,20);
     write (' Bereichs in die entsprechende Richtung. Die Leertaste schlielich dient');
     gotoxy (2,21);
     write (' zum Aufruf einer Bildschirmmaske, in die die Konstanten eingetragen werden');
     gotoxy (2,22);
     write (' knnen (nchste Seite). ');
     SetC (11,1);
     gotoxy (2,24);
     write ('  Bitte eine Taste drcken... ');

     ch := readkey;  IF ch = #0 THEN ch := readkey;
end;

{ gibt einige Konstanten auf dem GrafikScreen aus }
procedure wertAus;
var  outS : string;
begin
     reCalc; IF intern THEN exit;
     setFillStyle (0,0);
     bar (getMaxX shr 1,0,getMaxX,getMaxY shr 2);

     setTextStyle (0,0,0); setColor (15);
     reCalc;

     str (r, outS); outS := 'R = ' + outS;
     outTextXY (getMaxX- textWidth (outS) -20 , 2, outS );
     str (delta, outS); outS := ' = ' + outS;
     outTextXY (getMaxX- textWidth (outS) -20 , 14, outS );
     str (omega, outS); outS := ' = ' + outS;
     outTextXY (getMaxX- textWidth (outS) -20 , 26, outS );
     str ( (getMaxX + xadd )*zf , outS); outS := 't = ' + outS;
     outTextXY (getMaxX- textWidth (outS) -20 , 38, outS );
end;

{:-}
procedure videoOn;
begin
     IF intern THEN
      BEGIN
           asm mov ax,0013h; int 10h; end;
      END
     ELSE
      BEGIN
           initGraph (gd,gm,'');
           IF graphResult <> 0 THEN
            BEGIN
                 asm mov ax,0013h; int 10h; end;
                 intern := true;
            END
           ELSE { wenn init-ok, dann screen lschen, Achsen zeichnen, etc. }
            BEGIN
                 clearViewPort;
                 wertAus;
            END;
      END;
end;

begin
     IF (paramCount < 1) OR (paramStr(1)<>'i') THEN
      BEGIN
           intern := false;
           gd := detect;
      END
     ELSE intern := true;

     { Werte festlegen }
     L := 1;  C := 0.1;  U0 := 10;  R := 0;  xadd := 0; zf := 1/50; sf := 9;
     komplex := false; intC := 15; lineM := true; rf := 0.01; autoMode := false;
     showPage := 0;

     { Meldung an den Benutzer und Abfrage, ob Werte korrekt }
     reCalc;
     userInfo;
     userRequest;

     { System-Init }
     videoOn;

     { Eingang zeichnen }
     IF intern THEN clrScreen;
     plotFunc ( true );

     REPEAT
           IF autoMode THEN { automatik-Modus ohne 4-Gang-Getriebe. hehe. }
            BEGIN
                 plotFunc ( false );
                 R := R + rf;
                 zf := zf * 0.999;
                 wertAus;
                 plotFunc ( true );
            END;

           IF keyPressed THEN
            BEGIN
                 ch := readKey;
                 CASE ch OF
                 #27: { Ende }
                  sysDone := true;
                 #13: { ReDraw }
                  BEGIN
                       clrScreen;
                       wertAus;
                       plotFunc ( true );
                  END;
                 '+': { inc Widerstand }
                  BEGIN
                       R := R + rf;
                       wertAus;
                  END;
                 '-': { dec Widerstand }
                  BEGIN
                       R := R - rf;
                       wertAus;
                  END;
                 'p','P': { autoMode an/aus }
                  BEGIN
                       IF autoMode THEN autoMode := false
                       ELSE autoMode := true;
                  END;
                 'q','Q': { Stretchfaktor inc }
                  BEGIN
                       plotFunc (false);
                       sf := sf +1;
                       plotFunc (true);
                  END;
                 'a','A': { Stretchfaktor dec }
                  BEGIN
                       plotFunc (false);
                       sf := sf -1;
                       plotFunc (true);
                  END;
                 'w','W': { R Faktor erhhen }
                  BEGIN
                       rf := rf * 10;
                  END;
                 's','S': { R Faktor erniedrigen }
                  BEGIN
                       rf := rf / 10;
                  END;
                 'l','L': { Schaltet Line-Mode an und ab }
                  BEGIN
                       plotFunc ( false );
                       IF lineM THEN lineM := false
                       ELSE lineM := true;
                       plotFunc ( true );
                  END;
                 #32: { userRequest }
                  BEGIN
                       userRequest;
                       videoOn;
                       plotFunc ( true );
                  END;
                 #0,#224: { erweiterte Tastencodes }
                  BEGIN
                       ch := readkey;
                       CASE ch OF
                       #71: { home }
                        BEGIN
                             plotFunc ( false );
                             xadd := 0;
                             plotFunc ( true );
                        END;
                       #77: { right }
                        BEGIN
                             xadd := xadd + 1;
                        END;
                       #75: { left }
                        BEGIN
                             xadd := xadd - 1;
                             wertAus;
                        END;
                       #72: { up }
                        BEGIN
                             zf := zf *1.01;
                             wertAus;
                        END;
                       #80: { down }
                        BEGIN
                             zf := zf /1.01;
                             wertAus;
                        END;
                       END;
                  END;
                 END;
            END;
     UNTIL sysDone;

     asm mov ax,0003h; int 10h; end;
     write (' Untersuchung des Schwingungsablaufes bei gedmpften Pendeln. m. klossek 96     ');
     SetC (7,0);
end.