{$N+,E-}

uses crt;

{$L v3220pa}                               { Assembler-Modul einbinden }

procedure init320200; external;
procedure showpage( page : byte ); external;

const
  bmpfile : string = 's256x128.bmp';
  r       = 128;
  d       = 16;
  xadd    = 5;
  yadd    = 10;

type
  bldarr = array[0..63999] of byte;

var
  bmp    : pointer;
  scr    : pointer;
  dac    : array[0..255,0..2] of byte;
  x,y    : integer;
  f      : file;
  buf    : array[0..255] of byte;
  ang    : ^bldarr;
  wid    : ^bldarr;
  a      : byte;
  ar     : single;
  w      : byte;
  pos    : word;
  xa     : byte;
  ya     : byte;
  bpos   : word;
  page   : byte;
  sintab : array[0..255] of integer;

procedure initgraph; assembler;
asm
  mov  ax,13h
  int  10h
end;

procedure copyscreen; assembler;
asm
  push ds

  cmp  al,0
  jne  @weiter1
  xor  bx,bx
  jmp  @fertig
@weiter1:
  cmp  al,1
  jne  @weiter2
  mov  bx,65536/4
  jmp  @fertig
@weiter2:
  cmp  al,2
  jne  @weiter3
  mov  bx,65536/2
  jmp  @fertig
@weiter3:
  mov  bx,65536/4*2
@fertig:

  mov  ax,0A000h
  mov  es,ax        { ES auf Videosegment }
  mov  ds,word ptr scr+2
  cld

  mov  ah,1         { Pixel 0,4,8... }
  mov  al,2         { nach AL die Registernummer }
  mov  dx,03C4h     { Indexadresse des Sequencers laden }
  out  dx,ax        { Bit-Mask-Register laden }
  mov  cx,320*200/4 { Gre einer Plane }
  mov  di,bx
  xor  si,si
@loop1:
  movsb
  add  si,3
  loop @loop1

  mov  ah,4         { Pixel 0,4,8... }
  out  dx,ax        { Bit-Mask-Register laden }
  mov  cx,320*200/4 { Gre einer Plane }
  mov  di,bx
  mov  si,2
@loop3:
  movsb
  add  si,3
  loop @loop3

  mov  ah,2         { Pixel 0,4,8... }
  out  dx,ax        { Bit-Mask-Register laden }
  mov  cx,320*200/4 { Gre einer Plane }
  mov  di,bx
  mov  si,1
@loop2:
  movsb
  add  si,3
  loop @loop2

  mov  ah,8         { Pixel 0,4,8... }
  out  dx,ax        { Bit-Mask-Register laden }
  mov  cx,320*200/4 { Gre einer Plane }
  mov  di,bx
  mov  si,3
@loop4:
  movsb
  add  si,3
  loop @loop4

  pop  ds
end;

procedure initcostab;
var
  a : byte;
begin
  for a:=0 to 255 do sintab[a]:=round(sin(a*pi/128)*r*d);
end;

procedure loadbitmap;
var
  y   : byte;
begin
  assign(f,bmpfile);
  reset(f,1);
  seek(f,$36);
  for y:=0 to 255 do
    begin
    blockread(f,buf,4);
    dac[y,0]:=buf[2] shr 2;
    dac[y,1]:=buf[1] shr 2;
    dac[y,2]:=buf[0] shr 2;
    end;
  seek(f,$436);
  for y:=0 to 127 do
    begin
    blockread(f,buf,256);
    asm
      mov  es,word ptr bmp+2
      mov  bh,255
      sub  bh,y
      xor  bl,bl
      mov  di,bx
      mov  si,offset buf
      mov  cx,128
      rep  movsw
      add  bh,128
      mov  bl,64
      mov  cx,128
      mov  si,offset buf
    @schleife:
      mov  ax,ds:[si]
      mov  es:[bx],ax
      add  bl,2
      add  si,2
      loop @schleife
    end;
    end;
  close(f);
  asm
    mov  ax,seg dac
    mov  es,ax
    mov  dx,offset dac
    mov  ah,10h
    mov  al,12h
    xor  bx,bx
    mov  cx,256
    int  10h
  end;
end;

begin
  if paramcount<>0 then bmpfile:=paramstr(1);
  init320200;
  initcostab;
  getmem(scr,64000);
  getmem(bmp,$FFFF);
  getmem(ang,64000);
  getmem(wid,64000);
  fillchar(scr^,64000,0);
  fillchar(bmp^,$FFFF,0);
  fillchar(ang^,64000,0);
  fillchar(wid^,64000,0);
  loadbitmap;
  pos:=0;
  for y:=-99 to 0 do
    for x:=-159 to 0 do
      begin
      pos:=(y+99)*320+x+159;
      if x<0 then ar:=arctan(y/x);
      if x=0 then
        begin
        if y<0 then ar:=pi/2;
        if y=0 then ar:=0;
        end;
      a:=round((ar*128/pi));
      ang^[pos]:=a+128;
      ang^[(y+100)*320-1-pos mod 320]:=-a;
      ang^[63999-pos]:=a;
      ang^[(100-y)*320+pos mod 320]:=-a+128;
      if ((a<32) or (a>224)) or ((a>96) and (a<160)) then
        begin
        if x<>0 then w:=abs(round(sintab[(a+64) mod 256]/x))
          else w:=wid^[pos-1];
        end
        else
        begin
        if y<>0 then  w:=abs(round(sintab[a]/y))
          else w:=wid^[pos-1];
        end;
      wid^[pos]:=w;
      wid^[(y+100)*320-1-pos mod 320]:=w;
      wid^[63999-pos]:=w;
      wid^[(100-y)*320+pos mod 320]:=w;
      end;

  xa:=0;
  ya:=0;
  page:=1;
  repeat
  asm
    push ds

    mov  al,xa
    mov  ah,ya
    mov  si,ax
    mov  dx,word ptr ang+2
    db   08Eh,0E2h        { mov fs,dx }
    mov  dx,word ptr wid+2
    db   08Eh,0EAh        { mov gs,dx }
    mov  es,word ptr scr+2
    mov  ds,word ptr bmp+2

    xor  di,di

  @schleife:
    mov  ax,si

    db   064h,066h,08Bh,015h    { mov edx,fs:[di] }
    add  dl,al
    add  dh,al
    db   066h,0C1h,0C2h,010h    { rol edx,16 }
    add  dl,al
    add  dh,al

    db   065h,066h,08Bh,00Dh    { mov ecx,gs:[di] }
    add  cl,ah
    add  ch,ah
    db   066h,0C1h,0C1h,010h    { rol ecx,16 }
    add  cl,ah
    add  ch,ah

    mov  bl,dl
    mov  bh,cl
{    and  bh,7Fh        {}
    mov  al,[bx]

    mov  bl,dh
    mov  bh,ch
{    and  bh,7Fh        {}
    mov  ah,[bx]

    db   066h,0C1h,0E0h,010h    { shl eax,16 }
    db   066h,0C1h,0EAh,010h    { shr edx,16 }
    db   066h,0C1h,0E9h,010h    { shr ecx,16 }

    mov  bl,dl
    mov  bh,cl
{    and  bh,7Fh        {}
    mov  al,[bx]

    mov  bl,dh
    mov  bh,ch
{    and  bh,7Fh        {}
    mov  ah,[bx]

    db   066h,0ABh              { stosd }

    cmp  di,64000
    jb   @schleife

    pop  ds

    add  xa,xadd
    add  ya,yadd

    mov  al,page
    call copyscreen
    end;
    showpage(page);
    page:=1-page;
  until keypressed;
  freemem(wid,64000);
  freemem(ang,64000);
  freemem(bmp,$FFFF);
  freemem(scr,64000);
  textmode(co80);
end.
