{$M 50000,160000,160000}

program shell;

uses arcview, crt, crttools, dos, get_dir, viewfile;

type
  file_type     =       record
                          name   : string[12];   { file name }
                          suf    : string[3];    { file suffix }
                          attrib : word;         { file attrib }
                          date   : datetime;     { file date and time }
                          p_size : longint;      { packed size }
                          u_size : longint;      { unpacked size }
                          to_cont: boolean;      { volume: file to be continued ? }
                          cont   : boolean;      { volume: file began elsewhere ? }
                          dirnbr : word;         { fictive directory number of archived file }
                        end;

var
  c                     :       array [0..5] of byte;          { Chooseable Colours }
  files                 :       array [0..511] of file_type;
  f                     :       file;
  scroll_entry          :       integer;        { number of file under the highlighted bar }
  max_entry             :       integer;        { number of entries }
  first_entry           :       integer;        { number of first entry in listbox}
  type_of_archive       :       byte;           { 0:dir, 1:rar }
  directories           :       word;
  size                  :       longint;
  screenptr1            :       pointer;        { pointer to screen-data }
  update                :       boolean;
  oldy                  :       byte;           { old y cursor position before starting }
  arcfile               :       string;         { name of archive we are inside }
  arcdir                :       string;         { current 'directory inside the archive }


Function Determine_file: string;
var
  buf1  :  array[0..6] of byte;
begin;
  assign(f, files[scroll_entry].name+'.'+files[scroll_entry].suf);
  reset(f, 1);
  if filesize(f)<6 then begin;
    determine_file:='';
    close(f);
    exit;
  end;
  blockread(f, buf1, 7);
  if chr(buf1[$00])+chr(buf1[$01])='MZ' then determine_file:='EXE';
  if buf1[$00]=$52 then
    if buf1[$01]=$61 then
      if buf1[$02]=$72 then
        if buf1[$03]=$21 then
          if buf1[$04]=$1a then
            if buf1[$05]=$07 then
              if buf1[$06]=$00 then Determine_file:='RAR';
      close(f);
end;

Procedure Draw_dirname;
var
  buffer : string;
  buffer2: string;
  i      : byte;
begin;
  gotoxy(1,2); write('ͻͻ');
  getdir(0,buffer);
  if type_of_archive=1 then buffer:='RAR: '+buffer+'\'+arcfile;
  if length(buffer)>35 then begin;
    i:=1;
    repeat;
      inc(i);
    until ((buffer[i]='\')or(i>length(buffer)));
    repeat;
      inc(i);
    until ((buffer[i]='\')or(i>length(buffer)));
    buffer2:=copy(buffer,1,i)+'...';
    i:=length(buffer);
    repeat;
      dec(i);
    until ((buffer[i]='\')or(i=1));
    repeat;
      dec(i);
    until ((buffer[i]='\')or(i=1));
    buffer2:=buffer2+copy(buffer,i,length(buffer)-i+1);
    buffer:=buffer2;
  end;
  textcolor(c[$00]); textbackground(c[$01]);
  if length(buffer)<35 then gotoxy(2+(40-length(buffer)) div 2,2) else gotoxy(2,2);
   write(buffer);
  textcolor(c[$01]); textbackground(c[$00]);
end;

Procedure Quit;
begin;
  popscreen(screenptr1,0,4000);
  freemem(screenptr1,4000);
  halt;
end;

Procedure Search_old_dir;
{ Sets the highlighted bar automatically on the directorie you've just left }
label last_step;
var
  buf : string;
  buf2: string;
  i2  : word;
begin;
  getdir(0,buf);
  last_step:
  chdir('..');
  get_directory;
  getdir(0, buf2);
  if length(buf2)<>3 then buf2:=buf2+'\';
  for i2:=0 to max_entry do begin;
    if buf2+files[i2].name=buf then begin;
      scroll_entry:=i2;
      if i2-first_entry>15 then first_entry:=i2+1;
    end;
  end;
  update:=true;
end;

Procedure Search_arch;
{ Sets the highlighted bar automatically on the archive you've just left }
label last_step;
var
  i2  : word;
begin;
  for i2:=0 to max_entry do begin;
    if files[i2].name+'.'+files[i2].suf=arcfile then begin;
      scroll_entry:=i2;
      if i2-first_entry>55 then first_entry:=i2+1;
    end;
  end;
  update:=true;
  arcfile:='';
end;

Procedure Drawline(nbr: word);
var
  line : byte;
  x, y : byte;
begin;
  line:=nbr-first_entry;
  if line<19 then begin; x:=2; y:=line+3; end;
  if ((line>18)and(line<38)) then begin; x:=15; y:=line-19+3; end;
  if line> 37 then begin; x:=28; y:=line-38+3; end;
  gotoxy(x,y);
  if nbr=scroll_entry then begin;
    textcolor(c[$00]); textbackground(c[$01]);
    write('            ');
    gotoxy(x,y); write(files[nbr].name);
    gotoxy(x+9,y); write(files[nbr].suf);
    textcolor(c[$01]); textbackground(c[$00]);
  end else begin;
    write('            ');
    gotoxy(x,y); write(files[nbr].name);
    gotoxy(x+9,y); write(files[nbr].suf);
  end;
  Cursoroff;
end;

procedure Drawlist;
var
  i  :  byte;
begin;
  for i:=first_entry to first_entry+56 do drawline(i);

end;


procedure Draw_windows;
var
  i     :       byte;
begin;
  textcolor(c[$01]); textbackground(c[$00]);
  gotoxy(1,2);
  write('ͻͻ');
  for i:=3 to 21 do begin;
    gotoxy(1,i);
    write('                                                                        ');
  end;
  gotoxy(1,22);
  write('ĶĶ');
  gotoxy(1,23);
    write('                                                                            ');
  gotoxy(1,24);
  write('ͼ');
  memw[$b800:3838]:=$1b00+ord('');
end;

Procedure Main_init;
begin;
  oldy:=wherey;
  getmem(screenptr1,4000);
  pushscreen(screenptr1,0,4000);
  c[$00]:=$01;                          { background of main windows }
  c[$01]:=$0b;                          { written stuff inside the main Windows }
  init_arcview(@max_entry,@scroll_entry, @size, @files, @type_of_archive,
  @directories);
  init_getdir(@max_entry, @scroll_entry, @size, @files, @type_of_archive);
end;

procedure execute(cmd, par : string);
var
  i : byte;
  s : pointer;
begin;
  getmem(s,4000);
  pushscreen(s,0,4000);
  popscreen(screenptr1,0,4000);
  gotoxy(1,oldy);
  swapvectors;
  exec(cmd, par);
  i:=doserror;
  swapvectors;
  pushscreen(screenptr1,0,4000);
  asm
    mov ax, 3
    int 10h
  end;
  popscreen(s,0,4000);
  freemem(s,4000);
  if i <> 0 then begin;
    gotoxy(1,1); write('Error ! ');
    case i of
   2 :  write('file not found !');
   3 :  write('path not found !');
   5 :  write('access denied !');
   6 :  write('no valid handle !');
   8 :  write('not enough memory !');
  10 :  write('wrong environment !');
  11 :  write('no valid executable !');
  end;
  end;
  cursoroff;
end;

procedure Main;
var
 i:byte;
 buffer : string;
 old_arc_dir : string;
begin;
  get_directory;
  draw_dirname;
  drawlist;
  repeat;
    if update then update:=False;
    if keypressed then case readkey of
      #0 : case readkey of
        #61: if type_of_archive=0 then begin;
               buffer:=files[scroll_entry].name+'.'+files[scroll_entry].suf;
               if view(@buffer) <> 0 then halt;
             end;
        #71: if scroll_entry>0 then begin;
               update:=true;
               scroll_entry:=0;
               first_entry:=0;
             end;
        #72: if scroll_entry> 0 then begin;
               dec(scroll_entry);
               if scroll_entry<first_entry then begin;
                 update:=true;
                 dec(first_entry);
               end;
               drawline(scroll_entry);
               drawline(scroll_entry+1);
             end;
        #75 : {left} if scroll_entry>0 then begin;
                i:=scroll_entry;
                dec(scroll_entry,19);
                if scroll_entry<0 then scroll_entry:=0;
                if scroll_entry<first_entry then begin;
                  dec(first_entry,19);
                  update:=true;
                end;
                if first_entry<0 then begin;
                  first_entry:=0;
                  scroll_entry:=0;
                end;
                drawline(i);
                drawline(scroll_entry);
              end;
        #77: {right} if scroll_entry<max_entry-1 then begin;
             i:=scroll_entry;
             inc(scroll_entry,19);
             if scroll_entry>max_entry-1 then scroll_entry:=max_entry-1;
             if scroll_entry>first_entry+55 then begin;
               first_entry:=scroll_entry-38;
               update:=true;
             end;
             if ((first_entry+56 > max_entry)and(max_entry>56)) then begin;
               first_entry:=max_entry-57;
               if first_entry<0 then first_entry:=0;
               scroll_entry:=max_entry-1;
             end;
             drawline(i);
             drawline(scroll_entry);
             end;
        #79: if scroll_entry < pred(max_entry) then begin;
               update:=true;
               scroll_entry:=pred(max_entry);
               if max_entry>57 then first_entry:=max_entry-57 else first_entry:=0;
             end;
        #80: if scroll_entry < pred(max_entry) then begin;
               inc(scroll_entry);
               if scroll_entry-first_entry>56 then begin;
                 inc(first_entry);
                 update:=true;
               end;
               drawline(scroll_entry-1);
               drawline(scroll_entry);
             end;
      end;
      #13 : begin;
              buffer:=files[scroll_entry].name;
              if files[scroll_entry].suf<>'' then buffer:=buffer+'.'+files[scroll_entry].suf;
                if files[scroll_entry].attrib and $10 <> 0 then begin;
                  if type_of_archive=0 then begin;
                    if files[scroll_entry].name='..' then begin;
                      search_old_dir;
                      draw_dirname;
                    end else begin;
                      chdir(buffer);
                      get_directory;
                      draw_dirname;
                      update:=true;
                    end;
                  end else begin;
                    if files[scroll_entry].name='..' then begin;
                      if arcdir='' then begin;
                        get_directory;
                        search_arch;
                        draw_dirname;
                        update:=true;
                        arcdir:='';
                        arcfile:='';
                      end else begin;
                        i:=length(arcdir);
                        while ((i<>0)and(arcdir[i]<>'\')) do dec(i);
                        old_arc_dir:=copy(arcdir,i,length(arcdir)-i);
                        arcdir:=copy(arcdir,1,i);
                        look_rar_archive(arcfile,0);
                        i:=0;
                        while buffer<>old_arc_dir do begin;
                          buffer:=files[i].name;
                          if files[i].suf<>'' then buffer:=buffer+'.'+files[i].suf;
                          inc(i);
                        end;
                        dec(i);
                        scroll_entry:=i;
                        if scroll_entry>55 then first_entry:=scroll_entry;
                        update:=true;
                      end;
                    end else begin;
                      if arcfile='' then arcfile:=buffer else arcdir:=arcdir+buffer;
                      look_rar_archive(arcfile,0);
                      update:=true;
                    end;
                  end;
                end else begin;
                  if type_of_archive=0 then begin;
                    if determine_file='RAR' then begin;
                      if arcfile='' then arcfile:=buffer;
                      look_rar_archive(buffer,0);
                      look_rar_dir('');
                      draw_dirname;
                      update:=true;
                    end;
                    if ((files[scroll_entry].suf='exe') or (files[scroll_entry].suf='com')) then execute(buffer,'');
                    if ((files[scroll_entry].suf='bat') or (files[scroll_entry].suf='btm')) then
                      execute(getenv('COMSPEC'),' /C '+buffer);
                  end;
                end;
              end;
        #27 : quit;
    end;
    if update then drawlist;
  until 1=2;                            { neverending loop }
end;


begin;
  main_init;
  speedkey;
  draw_windows;
  cursoroff;
  main;
end.
