{ Unit:     TextWin.Pas
  Funktion: Textmodus-Oberflchenunit
  Autor:    M. Klosetti
  Sprache:  Borland Pascal 7.0 }

{$O+,F+} {$M 5000,0,0}
unit TextWin;

interface

uses mouse; { Maus-Funktionen }


const sRectsize     = 4006;                 { Gre des sRect-Arrays }
      menuFieldSize = 4347;                 { Gre des menuField-Arrays }

      Active           = 1;                 { Meneintragkonstanten }
      DeActive         = 3;
      Seperator        = 4;
      SelectedActive   = 2;
      SelectedDeActive = 5;
      PressedActive    = 6;

type sRect     = array[0..2002] of word;    { Bildschirmspeicher }
     pSRect    = ^sRect;                    { pointer auf Array }

     menuField = record
               srct      : sRect;
               posx,posy : byte;
               title     : string[80];
               entrys    : byte;
               highestwidth : byte;
               menucont  : string;
     end;
     pMenu      = ^menuField;

     WinCoors = record
              x1,x2,y1,y2 : byte;
              x,y         : byte;
              color       : word;
     end;

var  sBufbw : sRect absolute $b000:0000; { Arrays an den Bildschirmadressen }
     sBufco : sRect absolute $b800:0000;

     savX,savY    : byte;  { x,y - Koordinaten des DOS-Schirms }
     savDOSScreen : sRect; { Array fr Bildschirm }
     cDesktop     : byte;  { Zeichen fr Desktoppattern }
     tDesktop     : byte;  { Zeichenfarbe des Desktoppatterns }
     bDesktop     : byte;  { Hintergrundfarbe des Desktoppatterns }
     tMenu        : byte;  { Zeichenfarbe Menzeile }
     bMenu        : byte;  { Hintergrundfarbe Menzeile }
     atMenu       : byte;  { Zeichenfarbe aktivierter Menbalken }
     abMenu       : byte;  { Hintergrundfarbe aktivierter Menbalken }
     tMenuWindow  : byte;  { Textfarbe Men-Fenster }
     bMenuWindow  : byte;  { Hintergrundfarbe Men-Fenster }
     boMenuWindow : byte;  { Rahmenfarbe Men-Fenster }
     dtMenuWindow : byte;  { Textfarbe Menueintrag inaktiv }
     dbMenuWindow : byte;  { Hintergrundfarbe Menueintrag inaktiv }
     atMenuWindow : byte;  { Textfarbe Men-Fenster }
     abMenuWindow : byte;  { Hintergrundfarbe Men-Fenster }
     adtMenuWindow: byte;  { Textfarbe Menueintrag inaktiv }
     adbMenuWindow: byte;  { Hintergrundfarbe Menueintrag inaktiv }
     tStatus      : byte;  { Zeichenfarbe Statuszeile }
     bStatus      : byte;  { Hintergrundfarbe Statuszeile }
     tWindow      : byte;  { Textfarbe Fenster }
     boWindow     : byte;  { Rahmenfarbe Fenster }
     bWindow      : byte;  { Hintergrundfarbe Fenster }
     tErrorWindow : byte;  { Farbvariablen fr Error-Fenster }
     boErrorWindow: byte;
     bErrorWindow : byte;
     tButton      : byte;  { Farbvariablen fr Schalter }
     bButton      : byte;
     dtButton     : byte;
     dbButton     : byte;
     atButton     : byte;
     abButton     : byte;
     adtButton    : byte;
     adbButton    : byte;
     tInput       : byte;  { Farbvariablen fr Inputzeile }
     bInput       : byte;
     atInput      : byte;
     abInput      : byte;
     tScroll      : byte;  { Farbvariablen fr Scroller }
     bScroll      : byte;

     aktStatusText : string; { String fr den aktuellen StatusZeilenString }
     oldStatusText : string; { String fr alten StatusZeilenString }
     aktMenuText   : string; { String fr die aktuelle Menzeile }
     oldMenuText   : string; { String fr die alte Menzeile }

     stdStatusLine : string; { Standardstatuszeile im Hauptprogramm }
     stdMenuLine   : string; { Standardmenzeile im Hauptprogramm }

     GetVideoMode  : byte;   { Schwarzwei oder Farbe }

     callProc      : pointer;
     leaveInput    : boolean;


procedure SetC (text,back : byte);
 procedure PutChar (X,Y,attr,ch : byte; co : word);
 procedure DrawRect (left,top,right,bottom,text,back,ch : byte);
 procedure GetCurShape (var Shape : word);
 procedure SetCurShape (var Shape : word);
 procedure beep;
 function  funcGetVideoMode : byte;
 procedure CursorOn;
 procedure CursorOff;
 procedure center (text : string; zl,vf,hf,extras : byte);
 procedure setpage (p : byte);
 function  FileExist (fname : string) : boolean;

procedure crtwindow (left,top,right,bottom,text,back : byte);
 procedure crtbutton (left,top,right,bottom, ctext,cback,cdesk : byte; txt : string; typ,mode : byte);
 function  InputLine (x,y,scrlen,reallen,ctext,cfield,typ : byte;
              default : string; var KeyField : string; callS : boolean) : string;
 procedure DrawHScroller (left,top,right,percent,typ,fore,back : byte);
 procedure DrawVScroller (left,top,bottom,percent,typ,fore,back : byte);

procedure getscreen (var s : sRect);                    { Bildschirm gesamt lesen }
 procedure putscreen (var s : sRect);                   { Bildschirm gesamt schreiben }
 procedure getrect (x1,y1,x2,y2 : byte; var s : sRect); { Bildschirm-Teil lesen }
 procedure putrect (x1,y1,x2,y2 : byte; var s : sRect); { Bildschirm-Teil schreiben }
 procedure putrectext (var s : sRect);

procedure SetStdView;
 procedure GetWindowInf (var wco : WinCoors);
 procedure SetWindowInf (wco : WinCoors);
 procedure DrawStatusLine (LineText : string);
 procedure RestoreStatusLine;
 procedure DrawMenuLine (LineText : string);
 procedure RestoreMenuLine;

procedure InitDesktop (mode : byte);
 procedure InitSystemVars;
 procedure InitSystemColors;

procedure DoneDesktop;

function ActivatePopupMenu (MenuString : string; left,top : byte) : pMenu;
 procedure DeActivatePopupMenu (var menu : pMenu);
 procedure StandardMenuEntry (menu : pMenu; menupos : byte);
 procedure HighlightMenuEntry (menu : pMenu; menupos : byte);
 function  getmenutext (var menu : string; menupos : byte) : byte;
 procedure changemenutext (var menu : string; menupos : byte; switch : byte);
 procedure SelectMenuEntry (var menu : string; piM : pMenu; menupos : byte);
 procedure DeSelectMenuEntry (var menu : string; piM : pMenu; menupos : byte);

implementation

uses DOS,Crt;

var  CurShape        : word;
     CurPosX,CurPosY : byte;

{ Stellt den Dos-Bildschirm wieder her }
procedure DoneDesktop;
begin
     MouseOff;
      SetStdView;

     PutScreen (savDOSScreen);
      gotoxy (savX,savY);
      CursorOn;
end;

{ Initialisiert die Systemvariablen }
procedure InitSystemVars;
begin
     cDesktop:=176;

     aktStatusText:=''; oldStatusText:='';
     stdMenuLine:='  Datei Bearbeiten Optionen Hilfe';
     stdStatusLine:=' ESC Ende  ';
end;

{ Initialisiert die Systemfarben }
procedure InitSystemColors;
begin
     tDesktop:=1; { 1 }
     bDesktop:=7;

     tMenu:=15;
     bMenu:=1;
     atMenu:=1;
     abMenu:=7;
     tMenuWindow:=14;
     bMenuWindow:=1;
     boMenuWindow:=15;
     dtMenuWindow:=8;
     dbMenuWindow:=1;
     atMenuWindow:=1;
     abMenuWindow:=7;
     adtMenuWindow:=8;
     adbMenuWindow:=7;

     tStatus:=15;
     bStatus:=1;

     tWindow:=14;
     boWindow:=15;
     bWindow:=1;

     tErrorWindow:=15;
     boErrorWindow:=15;
     bErrorWindow:=4;

     tButton:=15;
     bButton:=7;
     dtButton:=8;
     dbButton:=1;
     atButton:=15;
     abButton:=4;
     adtButton:=15;
     adbButton:=1;

     tInput:=15;
     bInput:=7;
     atInput:=1;
     abInput:=7;

     tScroll:=1;
     bScroll:=3;
end;

{ Initialisiert den Bildschirm }
procedure InitDesktop (mode : byte);
begin
     GetVideoMode:=funcGetVideoMode;
     CursorOff; savX:=wherex; savY:=wherey;
     GetScreen (savDOSScreen);

     { mode hat folgende Bedeutung:
     0: nur DOS-Bildschirm Speichern
     1: zustzlich Pattern zeichnen
     2: Statuszeile
     3: Menzeile }

     case mode of
     1:
      begin
           DrawRect (1,1,80,25,tDesktop,bDesktop,cDesktop);
      end;
     2:
      begin
           DrawRect (1,1,80,25,tDesktop,bDesktop,cDesktop);
           DrawStatusLine (stdStatusLine);
      end;
     3:
      begin
           DrawRect (1,1,80,25,tDesktop,bDesktop,cDesktop);
           DrawStatusLine (stdStatusLine);
           DrawMenuLine (stdMenuLine);
      end;
     end;

     mouseon;
end;

{ Schaltet auf Standard-Sicht um }
procedure SetStdView;
begin
     window (1,1,80,25);
end;

{ Liest die Informationen des momentanen Pascal-Crt-Fensters aus }
procedure GetWindowInf (var wco : WinCoors);
begin
     wco.Color:=TextAttr;
     wco.x:=wherex;
     wco.y:=wherey;
     wco.x1:=lo(windmin);
     wco.y1:=hi(windmin);
     wco.x2:=lo(windmax);
     wco.y2:=hi(windmax);
end;

{ Setzt das Pascal-Crt-Fenster auf wco }
procedure SetWindowInf (wco : WinCoors);
begin
     TextAttr:=wco.Color;
     window (wco.x1+1,wco.y1+1,wco.x2+1,wco.y2+1);
     gotoxy (wco.x,wco.y);
end;

{ zeichnet Statuszeile }
procedure DrawStatusLine (LineText : string);
var  wco : WinCoors;
begin
     oldStatusText:=aktStatusText;
      aktStatusText:=LineText;
      if length(aktStatusText)>78 then aktStatusText:=copy (aktStatusText,1,80);

     GetWindowInf (wco);
      SetStdView;

     SetC (tStatus,bStatus);
      MouseOff;
      PutChar (0,24,textattr,32,80);
     gotoxy (1,25);
      write (aktStatusText);

     MouseOn;
      SetWindowInf (wco);
end;

{ Stellt die alte Statuszeile wieder her }
procedure RestoreStatusLine;
begin
     DrawStatusLine (oldStatusText);
end;

{ zeichnet Menzeile }
procedure DrawMenuLine (LineText : string);
var  wco : WinCoors;
begin
     oldMenuText:=aktMenuText;
      aktMenuText:=LineText;
      if length(aktMenuText)>78 then aktMenuText:=copy (aktMenuText,1,80);

     GetWindowInf (wco);
      SetStdView;

     SetC (tMenu,bMenu);
      MouseOff;
      PutChar (0,0,textattr,32,80);
     gotoxy (1,1);
      write (aktMenuText);

     MouseOn;
      SetWindowInf (wco);
end;

{ Stellt die alte Menzeile wieder her }
procedure RestoreMenuLine;
begin
     DrawMenuLine (oldMenuText);
end;

procedure getrect (x1,y1,x2,y2 : byte; var s : sRect);
var  x,y : byte;
begin
     MouseOff;
     if GetVideoMode=mono then
      begin
           for x:=x1 to x2 do
            for y:=y1 to y2 do
             s[x+80*y]:=sBufbw[x+80*y];
      end
     else
      begin
           for x:=x1 to x2 do
            for y:=y1 to y2 do
             s[x+80*y]:=sBufco[x+80*y];
      end;
     MouseOn;

     s[2001]:=x1*256+y1;
      s[2002]:=x2*256+y2;
end;

procedure putrect (x1,y1,x2,y2 : byte; var s : sRect);
var  x,y  : byte;
begin
     MouseOff;
     if GetVideoMode=mono then
      begin
           for x:=x1 to x2 do
            for y:=y1 to y2 do
             sBufbw[x+80*y]:=s[x+80*y];
      end
     else
      begin
           for x:=x1 to x2 do
            for y:=y1 to y2 do
             sBufco[x+80*y]:=s[x+80*y];
      end;
      MouseOn;
end;

procedure putrectext (var s : sRect);
var  x,y   : byte;
     x1,y1,x2,y2 : byte;
begin
     x1:=hi (s[2001]);
      y1:=lo (s[2001]);
      x2:=hi (s[2002]);
      y2:=lo (s[2002]);

     if (x1>80) or (x2>80) then exit;

     MouseOff;
     if GetVideoMode=mono then
      begin
           for x:=x1 to x2 do
            for y:=y1 to y2 do
             sBufbw[x+80*y]:=s[x+80*y];
      end
     else
      begin
           for x:=x1 to x2 do
            for y:=y1 to y2 do
             sBufco[x+80*y]:=s[x+80*y];
      end;
      MouseOn;
end;

procedure GetScreen (var s : sRect);
var  x,y  : byte;
begin
     MouseOff;
     if GetVideoMode=mono then
      begin
           for x:=0 to 79 do
            for y:=0 to 24 do
             s[x+80*y]:=sBufbw[x+80*y];
      end
     else
      begin
           for x:=0 to 79 do
            for y:=0 to 24 do
             s[x+80*y]:=sBufco[x+80*y];
      end;
     MouseOn;
end;

procedure PutScreen (var s : sRect);
var  x,y  : byte;
begin
     MouseOff;
     if GetVideoMode=mono then
      begin
           for x:=0 to 79 do
            for y:=0 to 24 do
             sBufbw[x+80*y]:=s[x+80*y];
      end
     else
      begin
           for x:=0 to 79 do
            for y:=0 to 24 do
             sBufco[x+80*y]:=s[x+80*y];
      end;
     MouseOn;
end;

{ Stellt fest, ob eine Datei existiert }
function FileExist (fname : string) : boolean;
var  sr : SearchRec;
begin
     findfirst (fname,$3f,sr);
     if (DosError=0) then FileExist:=true
     else FileExist:=false;
     if (IOResult<>0) then beep;
end;

procedure setpage (p:byte);
begin
     if (p<0) or (p>8) then exit;
     asm
        mov     ah,05
        mov     al,p
        int     10h
     end;
end;

function funcGetVideoMode : byte;
var  reg : registers;
begin
     reg.ah:=$0f;
     intr ($10,reg);
     GetVideoMode:=reg.al;
end;

{ Lt den Cursor verschwinden }
procedure CursorOff;
var  tv : word;
begin
     GetCurShape (CurShape);
     asm
        mov	ch,00100000b
        mov	cl,00000000b
        mov     tv,cx;
     end;
     SetCurShape (tv);
end;

{ Schaltet den Cursor wieder mnit dem ursprnglichen Wert ein }
procedure CursorOn;
begin
     { CurShape:=3342;}
     SetCurShape (CurShape);
end;

{ Positioniert einen String in der Mitte des Bildschirms, zl=zeile }
procedure center (text : string; zl,vf,hf,extras : byte);
var  tb : byte;
begin
     MouseOff;
     SetC (vf,hf);
     tb:=40 - length(text) div 2;
     gotoxy (tb,zl);
      write (text);
     MouseOn;
end;

{ Setzt die Standardfarbe neu. Text = Vordergrund, Back = Hintergrund }
procedure SetC (text,back : byte);
begin
     TextColor(text);
     TextBackground(back);
end;

{ Gibt einen Balken gleicher Zeichen aus }
procedure PutChar (X,Y,attr,ch : byte; co : word);
var  cha : byte;
begin
     MouseOff;
     cha:=ch;
     asm
        mov     dl,x
        mov     dh,y
        mov     ah,2
        mov     bh,0
        int     10h
        mov     ah,9
        mov     al,cha
        mov     bh,0
        mov     bl,attr
        mov     cx,co
        int     10h
     end;
     MouseOn;
end;

{ Zeichnet eine Flche gleicher Zeichen }
procedure DrawRect (left,top,right,bottom,text,back,ch : byte);
var  regv : word;
     attr,y : byte;
begin
     MouseOff;
     dec (right);
     dec (left);
     dec (top);
     dec (bottom);

     regv := right-left+1;

     SetC (15,0);
     attr:=16*back+text;

     for y:=top to bottom do
         PutChar (left,y,attr,ch,regv);

     window (1,1,80,25);
     SetC (text,back);
     MouseOn;
end;

{ Gibt einen Ton ber den internen Lautsprecher aus }
procedure beep;
begin
     sound (1000);
     delay (40);
     nosound;
end;

{ Zeichnet einen Schalter auf den Bildschirm }
procedure crtbutton (left,top,right,bottom, ctext,cback,cdesk : byte; txt : string; typ,mode : byte);
var  x,y,cx,cy : byte;
     r         : word;
     st        : string;
     regvx,regvy : word;
     attr,bc : byte;

 procedure Swap (var a,b : byte);
 var  r : byte;
 begin
      r:=a;
      a:=b;
      b:=r;
 end;

begin
     IF (bottom>25) OR (top>25) OR (left>80) OR (right>80) THEN exit;
     IF (bottom<top) THEN Swap (bottom,top);
     IF (right<left) THEN Swap (right,left);

     CASE typ OF
     1:
      BEGIN
           IF (bottom=top) THEN exit;
           x:=left; y:=top;
           SetC (ctext,cback);

           IF mode=Active THEN
            BEGIN
                 MouseOff;
                 FOR cy:=top TO bottom-1 DO
                  BEGIN
                       PutChar (left-1,cy-1,textattr,32,right-left);
                       IF cy<>top THEN PutChar (right-1,cy-1,0,32,1);
                  END;

                 textattr:=hi(sbufco[(top-1)*80+(right-1)]);
                 textattr:=cdesk shl 4;
                 PutChar (right-1,top-1,textattr,220,1);

                 FOR cy:=left+1 TO right DO
                  BEGIN
                       textattr:=hi(sbufco[(bottom-1)*80+(cy-1)]);
                       textattr:=cdesk shl 4;
                       PutChar (cy-1,bottom-1,textattr,223,1);
                  END;

                 SetC (cText,cBack);
                 IF length(txt)>right-left THEN st:=copy (txt,1,right-left)
                 ELSE st:=txt;

                 cx:=length(st) DIV 2;
                 cx:=(right-left) DIV 2 - cx;
                 cy:=(bottom-top-1) DIV 2;

                 GoToXY (left+cx,top+cy);
                 write (st); mouseon;
            END;
           IF mode=PressedActive THEN
            BEGIN
                 MouseOff;
                 r:=hi(sbufco[(top-1)*80+(right-1)]);

                 FOR cy:=top TO bottom-1 DO
                  BEGIN
                       PutChar (left,cy-1,textattr,32,right-left);
                       PutChar (left-1,cy-1,r,32,1);
                  END;

                 FOR cy:=left+1 TO right DO
                  BEGIN
                       textattr:=hi(sbufco[(bottom-1)*80+(cy-1)]);
                       PutChar (cy-1,bottom-1,textattr,32,1);
                  END;

                 SetC (cText,cBack);
                 IF length(txt)>right-left THEN st:=copy (txt,1,right-left)
                 ELSE st:=txt;

                 cx:=length(st) DIV 2;
                 cx:=(right-left) DIV 2 - cx;
                 cy:=(bottom-top-1) DIV 2;

                 GoToXY (left+cx+1,top+cy);
                 write (st); mouseon;
            END;
      END;
     2:
      BEGIN
           dec (left); dec (right); dec (top); dec (bottom);

           MouseOff;
           attr:=16*cback+ctext;
           regvx:=right-left+1;
           regvy:=bottom-top+1;

           if regvy<2 then
            begin
                putchar (left,top,attr,91,1);
                putchar (left+1,top,attr,32,regvx-1);
                putchar (right,top,attr,93,1);

                for y:=top+1 to bottom-1 do
                begin
                     putchar (left,y,attr,32,regvx);
                end;

                putchar (left,bottom,attr,32,regvx);
            end;
           if top=bottom then
            begin
                 putchar (left,top,attr,91,1);
                 putchar (left+1,top,attr,32,regvx-1);
                 putchar (right,top,attr,93,1);
                 y:=length(txt) div 2;
                 y:=regvx div 2-y;
                 y:=y+left+1;
                 SetC (ctext,cback);
                 gotoxy (y,top+1);
                 write (txt);
            end;
           MouseOn;
      END;
     END;
end;

{ Zeichnet ein Fenster auf den Bildschirm }
procedure crtwindow (left,top,right,bottom,text,back : byte);
var  regv     : word;
     attr,x,y : byte;
     gohe     : byte;

{ procedure s (x,y : byte); assembler;
 asm
      mov       ah,02
      mov       bh,0
      mov       dh,y
      mov       dl,x
      int       10h
      mov       ah,08
      mov       bh,0
      int       10h

      mov       ah,09
      mov       bh,0
      mov       bl,8
      mov       cx,1
      int       10h
 end; }

 procedure s (x,y : byte);
 begin
     if GetVideoMode=mono then
      sBufbw[80*y+x]:=sBufbw[80*y+x] AND $0F
     else
      sBufco[80*y+x]:=sBufco[80*y+x] AND $0F;
 end;

begin
     MouseOff;
      dec (right); dec (left);
      dec (top); dec (bottom);
      regv := right-left-2;
      attr:=16*back+text;

     textcolor (15);
      textbackground (0);

     PutChar (left,top,attr,218,1);
      PutChar (left+1,top,attr,196,regv);
      PutChar (right-1,top,attr,191,1);

     for y:=1 to bottom-top-2 do
     begin
         PutChar (left,top+y,attr,179,1);
          PutChar (left+1,top+y,attr,32,regv);
          PutChar (right-1,top+y,attr,179,1);
          IF right<80 THEN s (right,top+y);
     end;

     PutChar (left,bottom-1,attr,192,1);
      PutChar (left+1,bottom-1,attr,196,regv);
      PutChar (right-1,bottom-1,attr,217,1);
      IF right<80 THEN s (right,bottom-1);

     goHe:=right; IF goHe>79 THEN goHe:=79;
     for y:=left+1 to goHe do
       s (y,bottom);

     window (left+2,top+2,right-1,bottom-1);
      SetC (text,back);
      MouseOn;
end;

procedure GetCurXY; assembler;
asm
   mov	bh,0
   mov	ah,3h
   int	10h
    { ch,cl = CursorForm
     dh,dl = CursorPosition }
end;

{ Liest die Gre des Cursors aus }
procedure GetCurShape (var shape : word);
var  ar : word;
begin
     asm
        call  GetCurXY
	mov   ar,cx
     end;
     shape:=ar;
end;

{ Setzt die Gre des Cursors }
procedure SetCurShape (var Shape : word);
var  ar : word;
begin
     ar:=shape;
     asm
        mov     cx,ar
	mov	ah,1
	int	10h
     end;
end;

{ Liest einen String ber ein Eingabefeld ein.

 ->Eingabe
  x       : Bildschirmspalte
  y       : Bildschirmzeile
  scrlen  : Lnge des Eingabefeldes auf dem Bildschirm
  realen  : tatschliche, mgliche Lnge des Strings
  ctext   : Vordergrundfarbe
  cback   : Hintergrundfarbe
  default : Startwert im Eingabefeld
  typ     : Typ-Parameter
    1     : Alle Zeichen erlaubt, Abbruch mit Tab,Enter,Esc,Alt-Tab
    2     : Nur Zahlen erlaubt, Abbruch mit Tab,Enter,Esc,Alt-Tab
    3     : Alle Zeichen erlaubt, Abbruch mit allen anderen Tasten
    4     : Nur Zahlen erlaubt, Abbruch mit allen anderen Tasten

 <-Ausgabe
  InputLine : editierter String
  KeyField  : Tastendruck, der zum Abbruch fhrte }

function InputLine (x,y,scrlen,reallen,ctext,cfield,typ : byte; default : string;
                    var KeyField : string; callS : boolean ) : string;
var  cursorpos : byte;    { Cursorposition }
     stringpos : byte;    { Position im String }
     workstr   : string;  { Temporrer String }
     fl,fr     : boolean; { Flag fr rechten und linken Marker }

 procedure ShowString (strpos : byte);
 var  s1,s2 : string;
 begin
      s1:=copy (workstr,strpos,scrlen-2);
       fillchar (s2,scrlen-2-length(s1)+1,32); s2[0]:=chr(scrlen-2-length(s1));
       gotoxy (x+1,y);
       mouseoff;
       write (s1,s2);
       mouseon;
 end;

 procedure SetFlag (left,right : boolean);
 begin
      SetC (ctext,cfield);
       fl:=left; fr:=right;
       mouseoff;

      if left then
       begin
            gotoxy (x,y);
             write ('');
       end
      else
       begin
            gotoxy (x,y);
             write (' ');
       end;
      if right then
       begin
            gotoxy (x+scrlen-1,y);
             write ('');
       end
      else
       begin
            gotoxy (x+scrlen-1,y);
             write (' ');
       end;
       mouseon;
 end;

 procedure CheckFlag;
 begin
      if length(workstr)>scrlen-3 then { Erst hier ist eine Prfung notwendig }
       begin
            if StringPos=CursorPos-x then SetFlag (false,true);
            if (StringPos>CursorPos-x) and (StringPos+(scrlen-2-CursorPos+x)<length(workstr)) then SetFlag (true,true);
            if StringPos+(scrlen-2-CursorPos+x)>=length(workstr) then SetFlag (true,false);
       end
      else SetFlag (false,false);
 end;

 procedure SetCursor;
 begin
      gotoxy (CursorPos,y);
 end;

 procedure InsertChar (ch : char);
 begin
      if length(workstr)<reallen then
       begin
            insert (ch,workstr,StringPos);

            if CursorPos<x+scrlen-2 then
             begin
                  if CursorPos-x<length(workstr)+1 then inc (CursorPos);
                  if StringPos<length(workstr)+1 then inc (StringPos);
             end
            else
             begin
                  if StringPos<length(workstr)+1 then inc (StringPos);
             end;

             CheckFlag;
             ShowString (StringPos-(CursorPos-x)+1);
             SetCursor;
       end;
 end;

 procedure Init;
 begin
      DrawRect (x,y,x+scrlen-1,y,ctext,cfield,32);
      mouseoff;
      if length(default)<scrlen-2 then
       begin
            gotoxy (x+1,y);
             write (default);
             cursorpos:=length(default)+x+1;
             stringpos:=length(default)+1;
       end
      else
       begin
            gotoxy (x+1,y);
             write (copy (default,length(default)-scrlen+4,scrlen-2));
             SetFlag (true,false);
             cursorpos:=scrlen+x-2;
             stringpos:=length(default)+1;
       end;
      mouseon;
      workstr:=default;

      CursorOn;
      gotoxy (cursorpos,y);
 end;

 procedure Done;
 begin
      CursorOff;
 end;

 procedure Run;
 var  ch        : char;    { Variable fr Tastendrcke (readkey) }
      InputDone : boolean; { DialogSchlieen-Flag }
 begin
      InputDone:=false;
      repeat

            if keypressed then
             begin
                  ch:=readkey;

                  case ch of
                  #13:
                   begin
                        KeyField[1]:=#13;
                         KeyField[2]:=#0;
                         InputLine:=workstr;
                         InputDone:=true;
                   end;
                  #9:
                   begin
                        KeyField[1]:=#9;
                         KeyField[2]:=#0;
                         InputLine:=workstr;
                         InputDone:=true;
                   end;
                  #27:
                   begin
                        workstr:=default;
                         KeyField[1]:=#27;
                         KeyField[2]:=#0;
                         InputLine:=workstr;
                         InputDone:=true;
                   end;
                  #8: { Backspace }
                   begin
                        if (StringPos>1) then
                         begin
                              Delete (workstr,StringPos-1,1);
                               dec (StringPos);

                              if (StringPos-(CursorPos-x-2)=1) then
                               begin
                                    dec (CursorPos);
                               end;

                              CheckFlag;
                              ShowString (StringPos-(CursorPos-x)+1);
                              SetCursor;
                         end;
                   end;
                  #32..#255:
                   begin
                        if (Typ=1) or (Typ=3) then InsertChar (ch);
                   end;
                  #44,#46,#48..#57:
                   begin
                        if (Typ=2) or (Typ=4) then
                         begin
                              if ch=#44 then ch:=#46;
                              InsertChar (ch);
                         end;
                   end;
                  #0: { Funktionstasten }
                   begin
                        ch:=readkey;
                        case ch of
                        #15: { Shift-Tab }
                         begin
                              KeyField[1]:=#0;
                               KeyField[2]:=#15;
                               InputLine:=workstr;
                               InputDone:=true;
                         end;
                        #75: { Links }
                         begin
                              if CursorPos>x+1 then
                               begin
                                    dec (CursorPos);
                                    if StringPos>1 then dec (StringPos);
                               end
                              else
                               begin
                                    if StringPos>1 then dec (StringPos);
                                    ShowString (StringPos-(CursorPos-x)+1);
                               end;
                              CheckFlag;
                              SetCursor;
                         end;
                        #77: { Rechts }
                         begin
                              if CursorPos<x+scrlen-2 then
                               begin
                                    if CursorPos-x<length(workstr)+1 then inc (CursorPos);
                                    if StringPos<length(workstr)+1 then inc (StringPos);
                               end
                              else
                               begin
                                    if StringPos<length(workstr)+1 then inc (StringPos);
                                    ShowString (StringPos-(CursorPos-x)+1);
                               end;
                              CheckFlag;
                              SetCursor;
                         end;
                        #79:
                         begin  { Ende }
                                DrawRect (x+1,y,x+scrlen-2,y,ctext,cfield,32);
                                if length(workstr)<scrlen-2 then
                                 begin
                                      gotoxy (x+1,y);
                                      mouseoff;
                                      write (workstr);
                                      mouseon;
                                      cursorpos:=length(workstr)+x+1;
                                      stringpos:=length(workstr)+1;
                                 end
                                else
                                 begin
                                      gotoxy (x+1,y);
                                      mouseoff;
                                      write (copy (workstr,length(workstr)-scrlen+4,scrlen-2));
                                      mouseon;
                                      cursorpos:=scrlen+x-2;
                                      stringpos:=length(workstr)+1;
                                 end;

                                CheckFlag;
                                 SetCursor;
                         end;
                        #71: { Pos1 }
                         begin
                              StringPos:=1; CursorPos:=x+1;
                               ShowString (StringPos-(CursorPos-x)+1);
                               CheckFlag;
                               SetCursor;
                         end;
                        #83: { Entfernen }
                         begin
                              delete (WorkStr,StringPos,1);
                               CheckFlag;
                               ShowString (StringPos-(CursorPos-x)+1);
                               SetCursor;
                         end;
                        #61: { F3 - Alles lschen }
                         begin
                              WorkStr:='';
                               StringPos:=1; CursorPos:=x+1;
                               CheckFlag;
                               ShowString (StringPos-(CursorPos-x)+1);
                               SetCursor;
                         end;
                        else
                         if (Typ=3) or (Typ=4) then
                          begin
                               KeyField[1]:=#0;
                               KeyField[2]:=ch;
                               InputLine:=workstr;
                               InputDone:=true;
                          end;
                        end;
                   end;
                  else
                   begin
                        if (Typ=3) or (Typ=4) then
                         begin
                              KeyField[1]:=ch;
                              KeyField[2]:=#0;
                              InputLine:=workstr;
                              InputDone:=true;
                         end;
                   end;
                  end;
             end
            else
             IF callS THEN
             BEGIN
                  leaveInput:=false;
                  asm
                     mov  ax,ds
                     mov  es,ax
                     mov  di,offset callProc
                     push cs
                     call dword ptr es:[di]
                  end;

                  IF leaveInput THEN
                   BEGIN { Tab anzeigen }
                        KeyField[1]:=#9;
                        KeyField[2]:=#0;
                        InputLine:=workstr;
                        InputDone:=true;
                   END;
             END;

      until InputDone;
 end;

begin
     Init;
     Run;
     Done;
end;

{ Zeichnet einen horizontalen Scroller }
procedure DrawHScroller (left,top,right,percent,typ,fore,back : byte);
var  leftch,rightch,backch,scrollch : char;
     hb                             : byte;
begin
     case typ of
     1: { Borlandstyle }
      begin
           leftch:=#17; rightch:=#16;
            backch:=#177; scrollch:=#254;
      end;
     2:
      begin
           leftch:=#27; rightch:=#26;
            backch:=#32; scrollch:=#219;
      end;
     end;

     DrawRect (left+1,top,right-1,top,fore,back,ord(backch));
      SetC (fore,back);
      gotoxy (left,top);
      write (leftch);
      gotoxy (right,top);
      write (rightch);

     hb:=right-left-1;
      hb:=(hb * percent) div 100;
      gotoxy (left+1+hb,top);
      write (scrollch);
end;

{ Zeichnet einen vertikalen Scroller }
procedure DrawVScroller (left,top,bottom,percent,typ,fore,back : byte);
var  upch,downch,backch,scrollch  : char;
     hb                           : byte;
begin
     case typ of
     1: { Borlandstyle }
      begin
           upch:=#30; downch:=#31;
            backch:=#177; scrollch:=#254;
      end;
     2:
      begin
           upch:=#24; downch:=#25;
            backch:=#32; scrollch:=#219;
      end;
     end;

     DrawRect (left,top+1,left,bottom-1,fore,back,ord(backch));
      SetC (fore,back);
      gotoxy (left,top);
      write (upch);
      gotoxy (left,bottom);
      write (downch);

     hb:=bottom-top-2;
      hb:=(hb * percent) div 100;
      gotoxy (left,top+1+hb);
      write (scrollch);
end;

{ Activatepopupmenu zeichnet Popupmen

  MenuString = 'Titel:Anzahl:
                Eintrag:Status:
                Eintrag:Status:
                Eintrag:Status:
                ...' }

function ActivatePopupMenu (MenuString : string; left,top : byte) : pMenu;
var  st,st2,st3   : string;           { Temporre Strings }
     hb,hb2       : byte;             { Temporre Variablen }
     entrycount   : byte;             { Anzahl der Eintrge }
     title        : string;           { Titel des Mens }
     findmark     : byte;             { Position des Doppelpunkts }
     check        : word;             { Check-Variable fr val }
     highestwidth : byte;             { Lngster gefundener Meneintrag }
     menu         : pMenu;            { Pointer auf Hintergrundspeicher }
     rest         : string;           { Menueintrge }
     mode         : byte;             { Modus der Darstellung }
     wco          : WinCoors;

     lft,tp,right,bot : byte;
begin
     GetWindowInf (wco); SetStdView;
      st:=MenuString; highestwidth:=0;

     findmark:=pos (':',st);
      if findmark=0 then exit;

     title:=copy (st,1,findmark-1);
      st[findmark]:='';
      SetC (atMenu,abMenu);
      mouseoff;
      gotoxy (left,top);
      write (title);

     st2:=copy (st,findmark+1,pos (':',st)-findmark-1);
      val(st2,entrycount,check);
      if check<>0 then begin mouseon; exit; end;
      findmark:=pos (':',st);
      st[findmark]:='';
      rest:=copy (st,findmark+1,length(st)-findmark);

     for hb:=1 to entrycount do
      begin
           { Menueintrag }
           hb2:=pos (':',st)-findmark-1; { Lnge des Eintrags zwischen zwei Marks }
            findmark:=pos (':',st);      { Findmark auf nchsten Mark setzen }
            st[findmark]:='';           { Mark in Unmark umsetzen }
            if hb2>highestwidth then highestwidth:=hb2;

           { Menueintrag-Modus }
           findmark:=pos (':',st);       { Findmark auf nchsten Mark setzen }
            st[findmark]:='';           { Mark in Unmark umsetzen }
      end;
     if highestwidth=0 then begin mouseon; exit; end;
      right:=left+4+highestwidth;
      bot:=top+3+entrycount;

     menu:=nil; ActivatePopupMenu:=nil;
      if MaxAvail<menuFieldSize then begin mouseon; exit; end;
      getmem (menu,menuFieldSize);
      getrect (left-1,top,right-1,bot-1,menu^.srct);
      ActivatePopupMenu:=menu;

     menu^.title:=title;
      menu^.posx:=left;
      menu^.posy:=top;
      menu^.entrys:=entrycount;
      menu^.menucont:=rest;
      menu^.highestwidth:=highestwidth;

      { Menu-Fenster zeichnen }
     crtwindow (left,top+1,right,bot,boMenuWindow,bMenuWindow);
      SetStdView;

      { Menueintrge in das Menfenster eintragen }
     findmark:=0;
     for hb:=1 to entrycount do
      begin
            { Menueintrag }
           hb2:=pos (':',rest)-findmark-1; { Lnge des Eintrags zwischen zwei Marks }
            st2:=copy (rest,findmark+1,hb2); { Menutext in st2 ausschneiden }
            findmark:=pos (':',rest);      { Findmark auf nchsten Mark setzen }
            rest[findmark]:='';           { Mark in Unmark umsetzen }

            { Menueintrag-Modus }
           st3:=copy (rest,findmark+1,pos (':',rest)-findmark-1);
            val(st3,mode,check);
            if check<>0 then mode:=1;
            findmark:=pos (':',rest);    { Findmark auf nchsten Mark setzen }
            rest[findmark]:='';         { Mark in Unmark umsetzen }

            { Menueintrag zeichnen }
           case mode of
           1:
            begin
                 SetC (tMenuWindow,bMenuWindow);
                  gotoxy (left+1,top+1+hb);
                  write (' ',st2);
            end;
           2:
            begin
                 SetC (atMenuWindow,abMenuWindow);
                  gotoxy (left+1,top+1+hb);
                  st2:=' '+st2;
                  fillchar (st3[1],highestwidth-length(st2)+2,32);
                  st3[0]:=chr(highestwidth-length(st2)+2);
                  st2:=st2+st3;
                  write (st2);
            end;
           3:
            begin
                 SetC (dtMenuWindow,dbMenuWindow);
                  gotoxy (left+1,top+1+hb);
                  write (' ',st2);
            end;
           4:
            begin
                 SetC (boMenuWindow,bMenuWindow);
                  gotoxy (left,top+1+hb);
                  fillchar (st3[1],highestwidth+2,196);
                  st3[0]:=chr(highestwidth+2);
                  write (''+st3+'');
            end;
           5:
            begin
                 SetC (adtMenuWindow,adbMenuWindow);
                  gotoxy (left+1,top+1+hb);
                  st2:=' '+st2;
                  fillchar (st3[1],highestwidth-length(st2)+2,32);
                  st3[0]:=chr(highestwidth-length(st2)+2);
                  st2:=st2+st3;
                  write (st2);
            end;
           end;
      end;

     mouseon;
     SetWindowInf (wco);
end;

{ Lscht Popupmen wieder }
procedure DeActivatePopupMenu (var menu : pMenu);
var  wco : WinCoors;
begin
     if menu=nil then exit;
      GetWindowInf (wco);

     SetStdView;
      gotoxy (menu^.posx,menu^.posy);
      SetC (tMenu,bMenu);
      mouseoff;
      write (menu^.title);
      mouseon;

      { Bildschirm-Inhalt wieder zurckschreiben }
     putrectext (menu^.srct);
      SetWindowInf (wco);

      { Speicherbereich wieder lschen }
     freemem (menu,menuFieldSize);
      menu:=nil;
end;

{ Menueintrag wieder auf Standard stellen - Hilfsroutine fr Abfrageroutinen }
procedure DeSelectMenuEntry (var menu : string; piM : pMenu; menupos : byte);
 var  hb : byte;
 begin
      StandardMenuEntry (piM,menuPos);
       if getmenutext (menu,menuPos)=SelectedActive then hb:=Active;
       if getmenutext (menu,menuPos)=SelectedDeActive then hb:=DeActive;
       changemenutext (menu,menuPos,hb);
 end;

{ Menueintrag hell stellen - Hilfsroutine fr Abfrageroutinen }
procedure SelectMenuEntry (var menu : string; piM : pMenu; menupos : byte);
 var  hb : byte;
 begin
      HighlightMenuEntry (pim,menuPos);
       if getmenutext (menu,menuPos)=Active then hb:=SelectedActive;
       if getmenutext (menu,menuPos)=DeActive then hb:=SelectedDeActive;
       changemenutext (menu,menuPos,hb);
 end;

{ Verndert den Mode-Eintrag eines Meneintrags im Menstring }
procedure changemenutext (var menu : string; menupos : byte; switch : byte);
var  st,st2        : string;
     findmark      : byte;
     posmodeentry  : byte;
     sizemodeentry : byte;
     modeentry     : byte;
     hb1           : byte;
     code          : word;
begin
     if (switch>5) or (length(menu)=0) then exit;
      st:=menu;

      { Bis zum ersten Mnueintrag vorspulen }
     findmark:=pos (':',st);
      if findmark=0 then exit; { Keine Markierungen }
      st[findmark]:='';

     findmark:=pos (':',st);
      if findmark=0 then exit; { Keine Markierungen }
      st[findmark]:='';

      { Menueintrag suchen }
     for hb1:=1 to menupos do
      begin
           findmark:=pos (':',st);
            st[findmark]:='';

           st2:=copy (st,findmark+1,pos (':',st)-findmark-1);
            val (st2,modeentry,code);
            if code<>0 then exit;
            posmodeentry:=findmark+1;
            sizemodeentry:=pos (':',st)-findmark-1;
           findmark:=pos (':',st);
            st[findmark]:='';

           if modeentry=4 then
            begin
                 findmark:=pos (':',st);
                  st[findmark]:='';

                 posmodeentry:=findmark+1;
                  sizemodeentry:=pos (':',st)-findmark-1;
                  findmark:=pos (':',st);
                  st[findmark]:='';
            end;
      end;

      { Menueintrag ndern }
     delete (menu,posmodeentry,sizemodeentry);
      str (switch,st2);
      insert (st2,menu,posmodeentry);
end;

{ Liest den Mode-Eintrag eines Meneintrags im Menstring aus }
function getmenutext (var menu : string; menupos : byte) : byte;
var  st,st2        : string;
     findmark      : byte;
     posmodeentry  : byte;
     sizemodeentry : byte;
     modeentry     : byte;
     hb1           : byte;
     code          : word;
begin
     if (length(menu)=0) then exit;
      st:=menu;

      { Bis zum ersten Mnueintrag vorspulen }
     findmark:=pos (':',st);
      if findmark=0 then exit; { Keine Markierungen }
      st[findmark]:='';

     findmark:=pos (':',st);
      if findmark=0 then exit; { Keine Markierungen }
      st[findmark]:='';

      { Menueintrag suchen }
     for hb1:=1 to menupos do
      begin
           findmark:=pos (':',st);
            st[findmark]:='';

           st2:=copy (st,findmark+1,pos (':',st)-findmark-1);
            val (st2,modeentry,code);
            if code<>0 then exit;
            posmodeentry:=findmark+1;
            sizemodeentry:=pos (':',st)-findmark-1;
           findmark:=pos (':',st);
            st[findmark]:='';

           if modeentry=4 then
            begin
                 findmark:=pos (':',st);
                  st[findmark]:='';

                 st2:=copy (st,findmark+1,pos (':',st)-findmark-1);
                  val (st2,modeentry,code);
                  if code<>0 then exit;
                  posmodeentry:=findmark+1;
                  sizemodeentry:=pos (':',st)-findmark-1;
                 findmark:=pos (':',st);
                  st[findmark]:='';
            end;
      end;

      { Menueintrag zurckliefern }
     GetMenuText:=modeentry;
end;

{ Selektiert einen Menueintrag }
procedure HighlightMenuEntry (menu : pMenu; menupos : byte);
var  wco          : WinCoors;
     menuentry    : string;
     modeentry    : byte;
     posmodeentry : byte;
     sizemodentry : byte;

     st1,st2   : string;
     hb1,hb2   : byte;
     code      : word;
     findmark  : byte;
begin
      { 1.: Menueintrag suchen }

     if menupos>menu^.entrys then exit;
     findmark:=0; st1:=menu^.menucont; hb2:=0;

     for hb1:=1 to menupos do
      begin
           menuentry:=copy (st1,findmark+1,pos (':',st1)-findmark-1);
            findmark:=pos (':',st1);
            st1[findmark]:='';

           st2:=copy (st1,findmark+1,pos (':',st1)-findmark-1);
            val (st2,modeentry,code);
            if code<>0 then exit;
            posmodeentry:=findmark+1;
            sizemodentry:=pos (':',st1)-findmark-1;
           findmark:=pos (':',st1);
            st1[findmark]:='';
            inc (hb2);

           if modeentry=4 then
            begin
                 menuentry:=copy (st1,findmark+1,pos (':',st1)-findmark-1);
                  findmark:=pos (':',st1);
                  st1[findmark]:='';

                 st2:=copy (st1,findmark+1,pos (':',st1)-findmark-1);
                  val (st2,modeentry,code);
                  if code<>0 then exit;
                  posmodeentry:=findmark+1;
                  sizemodentry:=pos (':',st1)-findmark-1;
                 findmark:=pos (':',st1);
                  st1[findmark]:='';
                  inc (hb2);
            end;
      end;

      { 2.: Menueintrag in pMenu.menucont eintragen }
{     delete (menu^.menucont,posmodeentry,sizemodentry);
      insert ('2',menu^.menucont,posmodeentry);
}
      { 3.: Menueintrag zeichnen }
     GetWindowInf (wco);
      SetStdView;
      mouseoff;

     if ModeEntry>2 then SetC (adtMenuWindow,adbMenuWindow);
     if ModeEntry<3 then SetC (atMenuWindow,abMenuWindow);
      gotoxy (menu^.posx+1,menu^.posy+1+hb2);
      menuentry:=' '+menuentry;
       fillchar (st1[1],menu^.highestwidth-length(menuentry)+2,32);
       st1[0]:=chr(menu^.highestwidth-length(menuentry)+2);
      menuentry:=menuentry+st1;
      write (menuentry);

     SetWindowInf (wco);
      mouseon;
end;

{ Setzt einen Meneintrag auf normal }
procedure StandardMenuEntry (menu : pMenu; menupos : byte);
var  wco          : WinCoors;
     menuentry    : string;
     modeentry    : byte;
     posmodeentry : byte;
     sizemodentry : byte;

     st1,st2   : string;
     hb1,hb2   : byte;
     code      : word;
     findmark  : byte;
begin
      { 1.: Menueintrag suchen }

     if menupos>menu^.entrys then exit;
     findmark:=0; st1:=menu^.menucont; hb2:=0;

     for hb1:=1 to menupos do
      begin
           menuentry:=copy (st1,findmark+1,pos (':',st1)-findmark-1);
            findmark:=pos (':',st1);
            st1[findmark]:='';

           st2:=copy (st1,findmark+1,pos (':',st1)-findmark-1);
            val (st2,modeentry,code);
            if code<>0 then exit;
            posmodeentry:=findmark+1;
            sizemodentry:=pos (':',st1)-findmark-1;
           findmark:=pos (':',st1);
            st1[findmark]:='';
            inc (hb2);

           if modeentry=4 then
            begin
                 menuentry:=copy (st1,findmark+1,pos (':',st1)-findmark-1);
                  findmark:=pos (':',st1);
                  st1[findmark]:='';

                 st2:=copy (st1,findmark+1,pos (':',st1)-findmark-1);
                  val (st2,modeentry,code);
                  if code<>0 then exit;
                  posmodeentry:=findmark+1;
                  sizemodentry:=pos (':',st1)-findmark-1;
                 findmark:=pos (':',st1);
                  st1[findmark]:='';
                  inc (hb2);
            end;
      end;

      { 2.: Menueintrag in pMenu.menucont eintragen }
{     delete (menu^.menucont,posmodeentry,sizemodentry);
      insert ('1',menu^.menucont,posmodeentry);
}
      { 3.: Menueintrag zeichnen }
     GetWindowInf (wco);
      SetStdView;
      mouseoff;

     if ModeEntry<3 then SetC (tMenuWindow,bMenuWindow);
     if ModeEntry>2 then SetC (dtMenuWindow,dbMenuWindow);
      gotoxy (menu^.posx+1,menu^.posy+1+hb2);
      menuentry:=' '+menuentry;
       fillchar (st1[1],menu^.highestwidth-length(menuentry)+2,32);
       st1[0]:=chr(menu^.highestwidth-length(menuentry)+2);
      menuentry:=menuentry+st1;
      write (menuentry);

     SetWindowInf (wco);
      mouseon;
end;

begin
     callProc:=nil; leaveInput:=false;
end.
