{$m 1024, 300000, 300000}

{
 Programmname  :  WELLEN.EXE
 Zweck         :  Simulation von konzentrischen Wellen
 Erstellung    :  03.04.1996
 Sprache       :  Borland Pascal 7.0 (Inline ASM)
 Autor	       :  Fabian Wleklinski
 Auflsung     :  320*160
}

program wellen;

type byte_field   =  array [0..63999] of byte;
     byte_field_2 =  array [0..255] of byte;

var  i 	         :  byte;
     p1          :  ^byte_field;
     p2          :  ^byte_field;
     sinus       :  ^byte_field_2;
     square      :  array [0..319] of longint;
     x           :  longint;
     y           :  longint;
     x1	         :  integer;
     y1          :  integer;
     x2	         :  integer;
     y2          :  integer;
     abstand     :  byte;
     key	 :  byte;
     active_part :  boolean;
     mousex	 :  integer;
     mousey	 :  integer;
     mouse_key   :  byte;

procedure generate_radius_tab_1;	{ erzeugt Radius-Tabelle Nr. 1 }
var o : word;
begin;
  {$q-,r-}
  o:=20*320;
  x:=0;
  y:=20;
  repeat;
    repeat;
      p1^[o]:=round(sqrt( square[abs(x-x1)] + square[abs(y-y1)] ));
      inc(x);
      inc(o);
    until x=320;
    x:=0;
    inc(y);
  until y=180;
end;

procedure generate_radius_tab_2;	{ Erzeugt Radius-Tabelle Nr.2 }
var o : word;
begin;
  {$q-,r-}
  o:=20*320;
  x:=0;
  y:=20;
  repeat;
    repeat;
      p2^[o]:=round(sqrt( square[abs(x-x2)] + square[abs(y2-y)] ));
      inc(x);
      inc(o);
    until x=320;
    x:=0;
    inc(y);
  until y=180;
end;

procedure dispose_mem;			{ Gibt Speicher frei }
begin;
  freemem(p1, 64000);
  freemem(p2, 64000);
  freemem(sinus, 256);
end;

procedure restore_text_mode; assembler;	{ Schaltet in Textmodus }
asm
  mov ax, 3
  int 10h
end;

Procedure SetCol(col, r, g, b:byte); Assembler;	 { Verndert Farbpaletteneintrag }
asm
  mov dx, $3c8
  mov al, col
  out dx, al

  mov dx, $3c9
  mov al, r
  out dx, al

  mov al, g
  out dx, al

  mov al, b
  out dx, al
end;

procedure generate_sinus_tab;		{ Erzeugt Sinus-Tabelle }
begin;
  for x:=0 to 255 do sinus^[x]:=1+round( (sin(abstand*360*x*pi/256/180)+1) *31);
end;

procedure interprete_key;		{ Prft auf Tastendruck }
var
   update : byte;
begin;
  update:=0;
  case key of
    $4a : begin;
     	    if abstand<>255 then inc(abstand);
            generate_sinus_tab;
          end;
    $4e : begin;
            if abstand<>0 then dec(abstand);
            generate_sinus_tab;
          end;
    $39 : asm;
            xor ah, ah
            int 16h
    	  end;
    $15 : begin;
    	    dec(x1, 5);
            update:=1;
    	  end;
    $2d : begin;
            inc(x1, 5);
            update:=1;
    	  end;
    $10 : begin;
    	    dec(y1, 5);
            update:=1;
          end;
    $1e : begin;
    	    inc(y1, 5);
            update:=1;
          end;
    $34 : begin;     
    	    dec(x2, 5);
            update:=2;
    	  end;
    $35 : begin;
            inc(x2, 5);
            update:=2;
    	  end;
    $1b : begin;
    	    dec(y2, 5);
            update:=2;
          end;
    $28 : begin;
    	    inc(y2, 5);
            update:=2;
          end;
    $09 : begin;
    	    if not active_part then active_part:=true else active_part:=false;
          end;
  end;
  if update=1 then
  begin;
    if x1<0 then x1:=0;
    if x1>319 then x1:=319;
    if y1<0 then y1:=0;
    if y1>179 then y1:=179;
    generate_radius_tab_1;
  end;
  if update=2 then
  begin;
    if x2<0 then x2:=0;
    if x2>319 then x2:=319;
    if y2<0 then y2:=0;
    if y2>179 then y2:=179;
    generate_radius_tab_2;
  end;
  memw[$0040:$001C]:=memw[$0040:$001a]; { Keyboard-Buffer lschen }
end;

procedure mouse_moved;			{ berprft auf Mouse-Bewegung }
begin;
  if (mouse_key and 1) = 1 then begin;	{ Linke Mouse-Taste }
    inc(x1, mousex);
    inc(y1, mousey);
    if x1<0 then x1:=0;
    if x1>319 then x1:=319;
    if y1<0 then y1:=0;
    if y1>179 then y1:=179;
    generate_radius_tab_1;
  end;
  if (mouse_key and 2) = 2 then begin;	{ Rechte Mouse-Taste }
    inc(x2, mousex);
    inc(y2, mousey);
    if x2<0 then x2:=0;
    if x2>319 then x2:=319;
    if y2<0 then y2:=0;
    if y2>179 then y2:=179;
    generate_radius_tab_2;
  end;
end;

procedure asm_buildscreen; Assembler;	{ Hauptroutine }
asm
     jmp @screen_loop
  @time:
     db 0h
  @Screen_Loop:
     push ds
     push dx
      mov dx,$3da
  @x: in al, dx
      test al, 08h
      jnz @x
  @y: in al, dx
    test al, 08h
    jz @y
    pop dx

    mov ax, word ptr p1+2
    db 08eh, 0e0h			{ mov FS, AX }
					{ FS:00=Radius1 }
    mov ax, word ptr (p2+2)
    db 08eh, 0e8h			{ mov GS, AX }
    				        { GS:00=Radius2 }
    mov ds, word ptr (sinus+2)		{ DS:00=Sinus }
    push $a000
    pop es
    mov di, 20*320			{ ES:DI -> $A000:0 }
    mov dl, 159				{ DL == 'Y' }
    xor bh, bh
  @YLoop:
    mov dh, 80			        { CX == 'X' }
  @XLoop:
    db 64h, 66h, 08bh, 05h		{ mov eax, fs:[di] }
    db 65h, 66h, 08bh, 0dh		{ mov ecx, gs:[di] }
    mov bl, cs:byte ptr @time
    add al, bl
    add ah, bl
    add cl, bl
    add ch, bl
    db 66h, 0c1h, 0c0h, 10h		{ rol eax, 16 }
    db 66h, 0c1h, 0c1h, 10h		{ rol ecx, 16 }
    add al, bl
    add ah, bl
    add cl, bl
    add ch, bl

    mov bl, al
    mov al, ds:[bx]
    mov bl, ah
    mov ah, ds:[bx]
    mov bl, cl
    mov cl, ds:[bx]
    mov bl, ch
    mov ch, ds:[bx]
    add al, cl
    add ah, ch

    db 66h, 0c1h, 0c0h, 10h		{ rol eax, 16 }
    db 66h, 0c1h, 0c1h, 10h		{ rol ecx, 16 }

    mov bl, al
    mov al, ds:[bx]
    mov bl, ah
    mov ah, ds:[bx]
    mov bl, cl
    mov cl, ds:[bx]
    mov bl, ch
    mov ch, ds:[bx]
    add al, cl
    add ah, ch

    db 66h, 0abh			{ Stosd }
    dec dh
    jnz @XLoop
    dec dl
    jnz @YLoop
    dec cs:byte ptr @time
    pop ds

    mov ax, 3
    int 33h
    cmp bx, 0
    je @check_key
    mov mouse_key, bl
    mov ax, 0bh
    int 33h
    or cx, cx
    jne @mouse_moved
    or dx, dx
    jne @mouse_moved
    jmp @check_key
  @mouse_moved:
    mov mousex, cx
    mov mousey, dx
    call mouse_moved
  @check_key:
    mov ax, 0bh
    int 33h
    mov ah, 1
    int 16h
    jnz @key_pressed
    jmp @screen_Loop
  @key_pressed:
    xor ah, ah
    int 16h
    cmp al, 1bh
    je @ende
    mov key, ah
    call interprete_key
    jmp @screen_loop
  @ende:
end;

procedure define_colours;               { Definiert die Farbtabelle }
begin;
  for i:=1 to 128 do setcol(i, 0, 0, i div 2 );
  setcol(255, 0, 0, 0);
end;

procedure get_values;			{ Erfragt Werte vom Benutzer }
begin;
  abstand:=20;
  x1:=100;
  y1:=100;
  x2:=220;
  y2:=100;
end;

procedure build_screen;			{ Baut Graphikmaske auf }
begin;
  setcol(255, 63, 63, 63);
  for x:=0 to 319 do mem[$a000:x+320*19]:=255;
  for x:=0 to 319 do mem[$a000:x+320*179]:=255;
end;

procedure init_graph; assembler;	{ Schaltet in Grafikmodus }
asm
  mov ax, 13h
  int 10h
end;

procedure generate_square_tab;		{ Erzeugt Quadrattabelle }
begin;
  for x:=0 to 319 do square[x]:=sqr(x);
end;

procedure init_mem;			{ Besorgt Speicher fr Tabellen }
begin;
  getmem(p1, 64000);
  getmem(p2, 64000);
  getmem(sinus, 256);
end;

procedure init_Mouse; assembler;	{ Initialisiert Mouse-Treiber }
asm
  xor ax, ax
  int 33h				{ Maustreiber resetten }
  mov ax, 0002
  int 33h				{ Mauscursor verstecken }
end;

begin;
  init_mem;				{ Besorgt Speicher fr die Tabellen }
  get_values;				{ Erfragt Parameter vom Benutzer }
  generate_square_tab;			{ Legt Quadrattabelle an }
  generate_radius_tab_1;		{ Legt erste Tabelle mit Radien an }
  generate_radius_tab_2;		{ Legt zweite Tabelle mit Radien an }
  generate_sinus_tab;			{ Legt Tabelle mit Sinus-Werten an }
  init_graph;				{ Schaltet in den Grafikmodus }
  define_colours;			{ Definiert die Farbtabelle }
  build_screen;				{ Baut Graphikmaske auf }
  init_mouse;				{ Initialisiert Mouse-treiber }
  asm_buildscreen;			{ Hauptprozedur }
  restore_text_mode;			{ Schaltet wieder in den Textmodus }
  dispose_mem;				{ Gibt Speicher wieder frei }
end.